/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql;

import isql.array.Array;


/**
 * a table column (values + key)
 * @author SHZ Sep 26, 2007
 */
public class Column
{
	/**
	 * The array of values of the column
	 */
	private Array array;
	/**
	 * Identifies the column (table+column name)
	 */
	private ColumnKey key;
	public Column(ColumnKey key, Array array)
	{
		this.key = key;
		this.array = array;
	}
	/**
	 * @return the array
	 */
	public Array getArray()
	{
		return array;
	}
	/**
	 * @return the key
	 */
	public ColumnKey getKey()
	{
		return key;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{		
		return "[COLUMN "+key+": "+array+"]";
	}	
}
