/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql;

import static org.junit.Assert.assertEquals;
import isql.Equalizer.IArrayFuture;
import isql.array.Array;
import isql.constant.NumericConstant;
import isql.util.ArrayBuilder;

import org.junit.Test;

/**
 * @author SHZ Nov 7, 2007
 *
 */
public class EqualizerTest
{

	/**
	 * Test method for {@link isql.Equalizer#equalize()}.
	 * @throws ISQLException 
	 */
	@Test
	public void testEqualize() throws ISQLException
	{
		Equalizer equalizer = new Equalizer();
		IArrayFuture futureA = equalizer.add(new Array(ArrayBuilder.convertToBig(ColumnType.NUMERIC, new double[] { 12, 30, 33}), ColumnType.NUMERIC));
		IArrayFuture futureB = equalizer.add(new Array(ArrayBuilder.convertToBig(ColumnType.NUMERIC, new double[] { 44, 55, 66}), ColumnType.NUMERIC));
		IArrayFuture futureC = equalizer.add(new NumericConstant(Double.valueOf(33)));
		equalizer.equalize();
		for(IArrayFuture future : new IArrayFuture[] { futureA, futureB, futureC })
			assertEquals(future.getArray().getSize(), 3);
		Double[] arrC = (Double[])futureC.getArray().getArray();
		for(Double c : arrC)
			assertEquals(c, Double.valueOf(33));
	}
		
}
