/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql;

import java.util.Set;

/**
 * An expression is something that returns an array
 * @author SHZ Sep 27, 2007
 */
public interface IExpression
{
	/**
	 * Get the result of the expression (can be a constant or
	 * an array)
	 * @return the result
	 * @throws ISQLException
	 */
	public ITypedValue getResult() throws ISQLException;
	/**
	 * Returns the table columns named in the expression
	 * @return the identifiers of the columns
	 */
	public Set<ColumnKey> getInvolvedColumns();
}
