// $ANTLR 3.0 /home/andrea/prj/isql/ISQLSelect.g 2007-12-07 05:09:21

package isql;

import java.util.TreeMap;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

import org.antlr.runtime.tree.*;

@SuppressWarnings("unused")
public class ISQLSelectParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "COMMA", "LPAREN", "RPAREN", "StringLiteral", "Identifier", "LSQUARE", "RSQUARE", "DOT", "Number", "DateLiteral", "MINUS", "TILDE", "PLUS", "STAR", "DIVIDE", "MOD", "AMPERSAND", "BITWISEOR", "BITWISEXOR", "EQUAL", "NOTEQUAL", "LESSTHANOREQUALTO", "LESSTHAN", "GREATERTHANOREQUALTO", "GREATERTHAN", "COLON", "SEMICOLON", "Letter", "Digit", "Exponent", "WS", "'select'", "'all'", "'distinct'", "'where'", "'order'", "'by'", "'asc'", "'desc'", "'and'", "'or'", "'group'", "'not'", "'like'", "'in'", "'as'", "'from'", "'case'", "'when'", "'then'", "'else'", "'end'", "'any'", "'exists'", "'some'", "'true'", "'false'"
    };
    public static final int LESSTHAN=26;
    public static final int STAR=17;
    public static final int LSQUARE=9;
    public static final int MOD=19;
    public static final int BITWISEXOR=22;
    public static final int AMPERSAND=20;
    public static final int Exponent=33;
    public static final int SEMICOLON=30;
    public static final int RSQUARE=10;
    public static final int MINUS=14;
    public static final int Digit=32;
    public static final int EOF=-1;
    public static final int BITWISEOR=21;
    public static final int Identifier=8;
    public static final int LPAREN=5;
    public static final int NOTEQUAL=24;
    public static final int COLON=29;
    public static final int StringLiteral=7;
    public static final int GREATERTHANOREQUALTO=27;
    public static final int RPAREN=6;
    public static final int WS=34;
    public static final int Number=12;
    public static final int COMMA=4;
    public static final int DateLiteral=13;
    public static final int EQUAL=23;
    public static final int TILDE=15;
    public static final int PLUS=16;
    public static final int LESSTHANOREQUALTO=25;
    public static final int DOT=11;
    public static final int Letter=31;
    public static final int DIVIDE=18;
    public static final int GREATERTHAN=28;

        public ISQLSelectParser(TokenStream input) {
            super(input);
            ruleMemo = new HashMap[91+1];
         }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/home/andrea/prj/isql/ISQLSelect.g"; }


    public static class TableSource
    {
    private String table;
    private List<String> lstColumns = new ArrayList<String>(1);
    public void addColumn(String column) { lstColumns.add(column); }
    public List<String> getColumns() { return lstColumns; }
    public String getTable() { return table; }
    public void setTable(String table) { this.table = table; }
    }

    public static interface IConstant {}

    public static class NumberConstant implements IConstant
    {
    private double number;
    public NumberConstant(String sNumber) { this.number = Double.parseDouble(sNumber); }
    public double getNumber() { return number; }
    }

    public static class StringConstant implements IConstant
    {
    private String text;
    public StringConstant(String text) { this.text = text; }
    public String getText() { return text; }
    }

    public static class DateConstant implements IConstant
    {
    private String date;
    public DateConstant(String date) { this.date = date; }
    public String getDate() { return date; }
    }

    public static class BooleanConstant implements IConstant
    {
    private boolean value;
    public BooleanConstant(String booleanValue) { this.value = booleanValue.equalsIgnoreCase("true"); }
    public boolean getValue() { return value; }
    }


    public static class Function
    {
    private String functionId;
    private List<IExpression> lstParameter = new ArrayList<IExpression>(1);
    public void setFunctionId(String functionId) { this.functionId = functionId; }
    public void addParameter(IExpression parameter) { lstParameter.add(parameter); }
    public String getFunctionId() { return functionId; }
    public List<IExpression> getParameters() { return lstParameter; }
    }

    public static class SelectItem
    {
    private IExpression what;
    private String alias;
    public SelectItem(IExpression what, String alias) { this.what = what; this.alias = alias; }
    public IExpression getWhat() { return what; }
    public String getAlias() { return alias; }
    }

    public static class TableColumn
    {
    private String table;
    private String column;
    public TableColumn(String table, String column) { this.table = table; this.column = column; }
    public String getTable() { return table; }
    public String getColumn() { return column; }
    public String toString() { return table+"."+column; }
    }

    public static class When
    {
    private TableColumn test;
    private IConstant compared;
    private String operator;
    public When(TableColumn test, IConstant compared, String operator)
    {
    this.test = test;
    this.compared = compared;
    this.operator = operator;
    }
    public TableColumn getTest() { return test; }
    public IConstant getCompared() { return compared; }
    public String getOperator() { return operator; }
    }

    public static class WhenThen
    {
    private When when;
    private IExpression then;
    public WhenThen(When when, IExpression then)
    {
    this.when = when;
    this.then = then;
    }
    public When getWhen() { return when; }
    public IExpression getThen() { return then; }
    }

    public static class CaseFunction
    {
    private TableColumn test;
    private List<WhenThen> lstWhenThen = new ArrayList<WhenThen>(1);
    private IExpression expElse;
    public void setTest(TableColumn test) { this.test = test; }
    public void addWhenThen(WhenThen whenThen) { lstWhenThen.add(whenThen); }
    public void setElse(IExpression expElse) { this.expElse = expElse; }
    public TableColumn getTest() { return test; }
    public List<WhenThen> getWhenThens() { return lstWhenThen; }
    public IExpression getElse() { return expElse; }

    }

    public static interface IExpression {}


    public static class SimpleExpression implements IExpression
    {
    private SubExpression sub;
    public SimpleExpression(SubExpression sub) { this.sub = sub; }
    public SubExpression getSubExpression() { return sub; }
    }

    public static class ComplexExpression implements IExpression
    {
    private IExpression a;
    private IExpression b;
    private String operator;
    public ComplexExpression(IExpression a, IExpression b, String operator) 
    { 
    this.a = a; 
    this.b = b;
    this.operator = operator;
    }
    public IExpression getA() { return a; }
    public IExpression getB() { return b; }
    public String getOperator() { return operator; }
    }

    public static abstract class SubExpression 
    {
    private String unaryOperator = null;
    public void setUnaryOperator(String unaryOperator) { this.unaryOperator = unaryOperator; }
    public String getUnaryOperator() { return unaryOperator; }
    }

    public static class ConstantSubExpression extends SubExpression
    {
    private IConstant constant;
    public ConstantSubExpression(IConstant constant) { this.constant = constant; }
    public IConstant getConstant() { return constant; }
    }

    public static class FunctionSubExpression extends SubExpression
    {
    private Function function;
    public FunctionSubExpression(Function function) { this.function = function; }
    public Function getFunction() { return function; }
    }

    public static class ExpressionSubExpression extends SubExpression
    {
    private IExpression expression;
    public ExpressionSubExpression(IExpression expression) { this.expression = expression; }
    public IExpression getExpression() { return expression; }
    }

    public static class TableColumnSubExpression extends SubExpression
    {
    private TableColumn tableColumn;
    public TableColumnSubExpression(TableColumn tableColumn) { this.tableColumn = tableColumn; }
    public TableColumn getTableColumn() { return tableColumn; }
    }

    public static class CaseSubExpression extends SubExpression
    {
    private CaseFunction caseFunction;
    public CaseSubExpression(CaseFunction caseFunction) { this.caseFunction = caseFunction; }
    public CaseFunction getCase() { return caseFunction; }
    }

    public static interface IPredicate {}

    public static class Comparison implements IPredicate
    {
    private IExpression test;
    private IExpression compared;
    private String operator;
    public Comparison(IExpression test, IExpression compared, String operator)
    {
    this.test = test;
    this.compared = compared;
    this.operator = operator;
    }
    public IExpression getTest() { return test; }
    public IExpression getCompared() { return compared; }
    public String getOperator() { return operator; }
    }
    public static abstract class NegatePredicate implements IPredicate
    {
    private boolean negated = false;
    public void setNegated(boolean negated) { this.negated = negated; }
    public boolean isNegated() { return negated; }
    }

    public static class Like extends NegatePredicate
    {
    private IExpression test;
    private String compared;
    public Like(IExpression test, String compared)
    {
    this.test = test;
    if(compared != null)
    this.compared = compared.substring(1, compared.length() - 1);
    }
    public IExpression getTest() { return test; }
    public String getCompared() { return compared; }
    }

    public static class In extends NegatePredicate
    {
    private IExpression test;
    private List<IConstant> lstConstants;
    public In(IExpression test, List<IConstant> lstConstants)
    {
    this.test = test;
    this.lstConstants = lstConstants;
    }
    public IExpression getTest() { return test; }
    public List<IConstant> getConstants() { return lstConstants; }
    }

    public static interface ISearchCondition {}


    public static class SimpleSearchCondition implements ISearchCondition
    {
    private SubSearchCondition sub;
    public SimpleSearchCondition(SubSearchCondition sub) { this.sub = sub; }
    public SubSearchCondition getSubSearchCondition() { return sub; }
    }

    public static class ComplexSearchCondition implements ISearchCondition
    {
    private ISearchCondition a;
    private ISearchCondition b;
    private String operator;
    public ComplexSearchCondition(ISearchCondition a, ISearchCondition b, String operator) 
    { 
    this.a = a; 
    this.b = b;
    this.operator = operator;
    }
    public ISearchCondition getA() { return a; }
    public ISearchCondition getB() { return b; }
    public String getOperator() { return operator; }
    }

    public static abstract class SubSearchCondition
    {
    private boolean negated;
    public void setNegated(boolean negated) { this.negated = negated; }
    public boolean getNegated() { return negated; }
    }

    public static class RecursiveCondition extends SubSearchCondition
    {
    private ISearchCondition condition;
    public RecursiveCondition(ISearchCondition condition) { this.condition = condition; }
    public ISearchCondition getSearchCondition() { return condition; }
    }

    public static class PredicateCondition extends SubSearchCondition
    {
    private IPredicate predicate;
    public PredicateCondition(IPredicate predicate) { this.predicate = predicate; }
    public IPredicate getPredicate() { return predicate; }
    }

    public static class OrderBy
    {
    private TableColumn orderBy;
    private boolean ascendent = true;
    public OrderBy(TableColumn orderBy)
    {
    this.orderBy = orderBy;
    }
    public TableColumn getOrderBy() { return orderBy; }
    public void setAscendent(boolean ascendent) { this.ascendent = ascendent; }
    public boolean isAscendent() { return ascendent; }
    }


    private Map<String, TableSource> mapTableSource = new TreeMap<String, TableSource>();
    private void addTableSource(TableSource tableSource) { 
    if(tableSource != null) 
    {
    String table = tableSource.getTable();
    if(table != null)
    mapTableSource.put(table, tableSource); 
    }
    }
    public Map<String, TableSource> getTableSources() { return mapTableSource; }

    private List<SelectItem> lstSelectItem = new ArrayList<SelectItem>(1);
    private void addSelectItem(SelectItem item) { lstSelectItem.add(item); }
    public List<SelectItem> getSelectItems() { return lstSelectItem; }

    private List<TableColumn> lstGroupBy = new ArrayList<TableColumn>(1);
    private void addGroupBy(TableColumn groupBy) { lstGroupBy.add(groupBy); }
    public List<TableColumn> getGroupBys() { return lstGroupBy; }

    private List<OrderBy> lstOrderBy = new ArrayList<OrderBy>(1);
    private void addOrderBy(OrderBy orderBy) { lstOrderBy.add(orderBy); }
    public List<OrderBy> getOrderBys() { return lstOrderBy; }

    private ISearchCondition where;
    public ISearchCondition getWhere() { return where; }

    private boolean distinct;
    public boolean isDistinct() { return distinct; }


    public static class statement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start statement
    // /home/andrea/prj/isql/ISQLSelect.g:361:1: statement : selectStatement EOF ;
    public final statement_return statement() throws RecognitionException {
        statement_return retval = new statement_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token EOF2=null;
        selectStatement_return selectStatement1 = null;


        Object EOF2_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:362:5: ( selectStatement EOF )
            // /home/andrea/prj/isql/ISQLSelect.g:362:7: selectStatement EOF
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_selectStatement_in_statement65);
            selectStatement1=selectStatement();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, selectStatement1.getTree());
            EOF2=(Token)input.LT(1);
            match(input,EOF,FOLLOW_EOF_in_statement67); if (failed) return retval;
            if ( backtracking==0 ) {
            EOF2_tree = (Object)adaptor.create(EOF2);
            adaptor.addChild(root_0, EOF2_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end statement

    public static class selectStatement_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectStatement
    // /home/andrea/prj/isql/ISQLSelect.g:365:1: selectStatement : selectClause fromClause ( whereClause )? ( groupByClause )? ( orderByClause )? ;
    public final selectStatement_return selectStatement() throws RecognitionException {
        selectStatement_return retval = new selectStatement_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        selectClause_return selectClause3 = null;

        fromClause_return fromClause4 = null;

        whereClause_return whereClause5 = null;

        groupByClause_return groupByClause6 = null;

        orderByClause_return orderByClause7 = null;



        try {
            // /home/andrea/prj/isql/ISQLSelect.g:366:5: ( selectClause fromClause ( whereClause )? ( groupByClause )? ( orderByClause )? )
            // /home/andrea/prj/isql/ISQLSelect.g:367:5: selectClause fromClause ( whereClause )? ( groupByClause )? ( orderByClause )?
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_selectClause_in_selectStatement85);
            selectClause3=selectClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, selectClause3.getTree());
            pushFollow(FOLLOW_fromClause_in_selectStatement91);
            fromClause4=fromClause();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, fromClause4.getTree());
            // /home/andrea/prj/isql/ISQLSelect.g:369:5: ( whereClause )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==38) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:369:6: whereClause
                    {
                    pushFollow(FOLLOW_whereClause_in_selectStatement98);
                    whereClause5=whereClause();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, whereClause5.getTree());

                    }
                    break;

            }

            // /home/andrea/prj/isql/ISQLSelect.g:370:5: ( groupByClause )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==45) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:370:6: groupByClause
                    {
                    pushFollow(FOLLOW_groupByClause_in_selectStatement107);
                    groupByClause6=groupByClause();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, groupByClause6.getTree());

                    }
                    break;

            }

            // /home/andrea/prj/isql/ISQLSelect.g:371:5: ( orderByClause )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==39) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:371:6: orderByClause
                    {
                    pushFollow(FOLLOW_orderByClause_in_selectStatement116);
                    orderByClause7=orderByClause();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, orderByClause7.getTree());

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectStatement

    public static class selectClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectClause
    // /home/andrea/prj/isql/ISQLSelect.g:375:1: selectClause : 'select' (selectHow= ( 'all' | 'distinct' ) )? selectList ;
    public final selectClause_return selectClause() throws RecognitionException {
        selectClause_return retval = new selectClause_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token selectHow=null;
        Token string_literal8=null;
        selectList_return selectList9 = null;


        Object selectHow_tree=null;
        Object string_literal8_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:376:5: ( 'select' (selectHow= ( 'all' | 'distinct' ) )? selectList )
            // /home/andrea/prj/isql/ISQLSelect.g:377:5: 'select' (selectHow= ( 'all' | 'distinct' ) )? selectList
            {
            root_0 = (Object)adaptor.nil();

            string_literal8=(Token)input.LT(1);
            match(input,35,FOLLOW_35_in_selectClause145); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal8_tree = (Object)adaptor.create(string_literal8);
            adaptor.addChild(root_0, string_literal8_tree);
            }
            // /home/andrea/prj/isql/ISQLSelect.g:377:14: (selectHow= ( 'all' | 'distinct' ) )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( ((LA4_0>=36 && LA4_0<=37)) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:377:15: selectHow= ( 'all' | 'distinct' )
                    {
                    selectHow=(Token)input.LT(1);
                    if ( (input.LA(1)>=36 && input.LA(1)<=37) ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(selectHow));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_selectClause150);    throw mse;
                    }

                    if ( backtracking==0 ) {
                       distinct=(selectHow.getText().equalsIgnoreCase("distinct")); 
                    }

                    }
                    break;

            }

            pushFollow(FOLLOW_selectList_in_selectClause169);
            selectList9=selectList();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, selectList9.getTree());

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectClause

    public static class whereClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start whereClause
    // /home/andrea/prj/isql/ISQLSelect.g:382:1: whereClause : 'where' searchCondition ;
    public final whereClause_return whereClause() throws RecognitionException {
        whereClause_return retval = new whereClause_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal10=null;
        searchCondition_return searchCondition11 = null;


        Object string_literal10_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:383:5: ( 'where' searchCondition )
            // /home/andrea/prj/isql/ISQLSelect.g:384:5: 'where' searchCondition
            {
            root_0 = (Object)adaptor.nil();

            string_literal10=(Token)input.LT(1);
            match(input,38,FOLLOW_38_in_whereClause192); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal10_tree = (Object)adaptor.create(string_literal10);
            adaptor.addChild(root_0, string_literal10_tree);
            }
            pushFollow(FOLLOW_searchCondition_in_whereClause194);
            searchCondition11=searchCondition();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, searchCondition11.getTree());
            if ( backtracking==0 ) {
               where = searchCondition11.c; 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end whereClause

    public static class orderByClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start orderByClause
    // /home/andrea/prj/isql/ISQLSelect.g:388:1: orderByClause : 'order' 'by' first= orderByExpression ( COMMA other= orderByExpression )* ;
    public final orderByClause_return orderByClause() throws RecognitionException {
        orderByClause_return retval = new orderByClause_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal12=null;
        Token string_literal13=null;
        Token COMMA14=null;
        orderByExpression_return first = null;

        orderByExpression_return other = null;


        Object string_literal12_tree=null;
        Object string_literal13_tree=null;
        Object COMMA14_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:389:5: ( 'order' 'by' first= orderByExpression ( COMMA other= orderByExpression )* )
            // /home/andrea/prj/isql/ISQLSelect.g:390:5: 'order' 'by' first= orderByExpression ( COMMA other= orderByExpression )*
            {
            root_0 = (Object)adaptor.nil();

            string_literal12=(Token)input.LT(1);
            match(input,39,FOLLOW_39_in_orderByClause219); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal12_tree = (Object)adaptor.create(string_literal12);
            adaptor.addChild(root_0, string_literal12_tree);
            }
            string_literal13=(Token)input.LT(1);
            match(input,40,FOLLOW_40_in_orderByClause221); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal13_tree = (Object)adaptor.create(string_literal13);
            adaptor.addChild(root_0, string_literal13_tree);
            }
            pushFollow(FOLLOW_orderByExpression_in_orderByClause225);
            first=orderByExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, first.getTree());
            if ( backtracking==0 ) {
               addOrderBy(first.o); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:391:5: ( COMMA other= orderByExpression )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==COMMA) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:391:6: COMMA other= orderByExpression
            	    {
            	    COMMA14=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_orderByClause234); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA14_tree = (Object)adaptor.create(COMMA14);
            	    adaptor.addChild(root_0, COMMA14_tree);
            	    }
            	    pushFollow(FOLLOW_orderByExpression_in_orderByClause238);
            	    other=orderByExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, other.getTree());
            	    if ( backtracking==0 ) {
            	       addOrderBy(other.o); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end orderByClause

    public static class orderByExpression_return extends ParserRuleReturnScope {
        public OrderBy o;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start orderByExpression
    // /home/andrea/prj/isql/ISQLSelect.g:394:1: orderByExpression returns [ OrderBy o] : orderBy= tableColumn (ascDesc= ( 'asc' | 'desc' ) )? ;
    public final orderByExpression_return orderByExpression() throws RecognitionException {
        orderByExpression_return retval = new orderByExpression_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token ascDesc=null;
        tableColumn_return orderBy = null;


		Object ascDesc_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:395:5: (orderBy= tableColumn (ascDesc= ( 'asc' | 'desc' ) )? )
            // /home/andrea/prj/isql/ISQLSelect.g:396:5: orderBy= tableColumn (ascDesc= ( 'asc' | 'desc' ) )?
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_tableColumn_in_orderByExpression275);
            orderBy=tableColumn();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, orderBy.getTree());
            if ( backtracking==0 ) {
               retval.o = new OrderBy(orderBy.t); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:397:5: (ascDesc= ( 'asc' | 'desc' ) )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( ((LA6_0>=41 && LA6_0<=42)) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:397:6: ascDesc= ( 'asc' | 'desc' )
                    {
                    ascDesc=(Token)input.LT(1);
                    if ( (input.LA(1)>=41 && input.LA(1)<=42) ) {
                        input.consume();
                        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(ascDesc));
                        errorRecovery=false;failed=false;
                    }
                    else {
                        if (backtracking>0) {failed=true; return retval;}
                        MismatchedSetException mse =
                            new MismatchedSetException(null,input);
                        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_orderByExpression286);    throw mse;
                    }

                    if ( backtracking==0 ) {
                        retval.o.setAscendent(ascDesc.getText().equalsIgnoreCase("asc")); 
                    }

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end orderByExpression

    public static class searchCondition_return extends ParserRuleReturnScope {
        public ISearchCondition c;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start searchCondition
    // /home/andrea/prj/isql/ISQLSelect.g:401:1: searchCondition returns [ISearchCondition c;] : first= subSearchCondition (operator= ( 'and' | 'or' ) other= subSearchCondition )* ;
    public final searchCondition_return searchCondition() throws RecognitionException {
        searchCondition_return retval = new searchCondition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token operator=null;
        subSearchCondition_return first = null;

        subSearchCondition_return other = null;


        Object operator_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:402:5: (first= subSearchCondition (operator= ( 'and' | 'or' ) other= subSearchCondition )* )
            // /home/andrea/prj/isql/ISQLSelect.g:403:5: first= subSearchCondition (operator= ( 'and' | 'or' ) other= subSearchCondition )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_subSearchCondition_in_searchCondition325);
            first=subSearchCondition();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, first.getTree());
            if ( backtracking==0 ) {
               retval.c = new SimpleSearchCondition(first.s); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:404:5: (operator= ( 'and' | 'or' ) other= subSearchCondition )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( ((LA7_0>=43 && LA7_0<=44)) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:404:7: operator= ( 'and' | 'or' ) other= subSearchCondition
            	    {
            	    operator=(Token)input.LT(1);
            	    if ( (input.LA(1)>=43 && input.LA(1)<=44) ) {
            	        input.consume();
            	        if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(operator));
            	        errorRecovery=false;failed=false;
            	    }
            	    else {
            	        if (backtracking>0) {failed=true; return retval;}
            	        MismatchedSetException mse =
            	            new MismatchedSetException(null,input);
            	        recoverFromMismatchedSet(input,mse,FOLLOW_set_in_searchCondition337);    throw mse;
            	    }

            	    pushFollow(FOLLOW_subSearchCondition_in_searchCondition347);
            	    other=subSearchCondition();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, other.getTree());
            	    if ( backtracking==0 ) {
            	       retval.c = new ComplexSearchCondition(retval.c, new SimpleSearchCondition(other.s), operator.getText()); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end searchCondition

    public static class groupByClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start groupByClause
    // /home/andrea/prj/isql/ISQLSelect.g:407:1: groupByClause : 'group' 'by' groupBy= tableColumn ( COMMA tableColumn )* ;
    public final groupByClause_return groupByClause() throws RecognitionException {
        groupByClause_return retval = new groupByClause_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal15=null;
        Token string_literal16=null;
        Token COMMA17=null;
        tableColumn_return groupBy = null;

        tableColumn_return tableColumn18 = null;


        Object string_literal15_tree=null;
        Object string_literal16_tree=null;
        Object COMMA17_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:408:5: ( 'group' 'by' groupBy= tableColumn ( COMMA tableColumn )* )
            // /home/andrea/prj/isql/ISQLSelect.g:409:5: 'group' 'by' groupBy= tableColumn ( COMMA tableColumn )*
            {
            root_0 = (Object)adaptor.nil();

            string_literal15=(Token)input.LT(1);
            match(input,45,FOLLOW_45_in_groupByClause379); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal15_tree = (Object)adaptor.create(string_literal15);
            adaptor.addChild(root_0, string_literal15_tree);
            }
            string_literal16=(Token)input.LT(1);
            match(input,40,FOLLOW_40_in_groupByClause381); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal16_tree = (Object)adaptor.create(string_literal16);
            adaptor.addChild(root_0, string_literal16_tree);
            }
            pushFollow(FOLLOW_tableColumn_in_groupByClause385);
            groupBy=tableColumn();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, groupBy.getTree());
            if ( backtracking==0 ) {
               addGroupBy(groupBy.t); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:410:5: ( COMMA tableColumn )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==COMMA) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:410:6: COMMA tableColumn
            	    {
            	    COMMA17=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_groupByClause394); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA17_tree = (Object)adaptor.create(COMMA17);
            	    adaptor.addChild(root_0, COMMA17_tree);
            	    }
            	    pushFollow(FOLLOW_tableColumn_in_groupByClause396);
            	    tableColumn18=tableColumn();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, tableColumn18.getTree());
            	    if ( backtracking==0 ) {
            	       addGroupBy(groupBy.t); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end groupByClause

    public static class subSearchCondition_return extends ParserRuleReturnScope {
        public SubSearchCondition s;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start subSearchCondition
    // /home/andrea/prj/isql/ISQLSelect.g:416:1: subSearchCondition returns [SubSearchCondition s; ] : ( 'not' )? ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) ) ;
    public final subSearchCondition_return subSearchCondition() throws RecognitionException {
        subSearchCondition_return retval = new subSearchCondition_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal19=null;
        Token LPAREN20=null;
        Token RPAREN21=null;
        searchCondition_return recCondition = null;

        predicate_return predCondition = null;


        Object string_literal19_tree=null;
        Object LPAREN20_tree=null;
        Object RPAREN21_tree=null;

         boolean negated=false; 
        try {
            // /home/andrea/prj/isql/ISQLSelect.g:417:5: ( ( 'not' )? ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) ) )
            // /home/andrea/prj/isql/ISQLSelect.g:418:5: ( 'not' )? ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) )
            {
            root_0 = (Object)adaptor.nil();

            // /home/andrea/prj/isql/ISQLSelect.g:418:5: ( 'not' )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==46) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:418:6: 'not'
                    {
                    string_literal19=(Token)input.LT(1);
                    match(input,46,FOLLOW_46_in_subSearchCondition434); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal19_tree = (Object)adaptor.create(string_literal19);
                    adaptor.addChild(root_0, string_literal19_tree);
                    }
                    if ( backtracking==0 ) {
                       negated = true; 
                    }

                    }
                    break;

            }

            // /home/andrea/prj/isql/ISQLSelect.g:418:34: ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) )
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==LPAREN) ) {
                int LA10_1 = input.LA(2);

                if ( (synpred14()) ) {
                    alt10=1;
                }
                else if ( (true) ) {
                    alt10=2;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("418:34: ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) )", 10, 1, input);

                    throw nvae;
                }
            }
            else if ( ((LA10_0>=StringLiteral && LA10_0<=Identifier)||(LA10_0>=Number && LA10_0<=TILDE)||(LA10_0>=59 && LA10_0<=60)) ) {
                alt10=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("418:34: ( ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN ) | (predCondition= predicate ) )", 10, 0, input);

                throw nvae;
            }
            switch (alt10) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:419:11: ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN )
                    {
                    // /home/andrea/prj/isql/ISQLSelect.g:419:11: ( ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN )
                    // /home/andrea/prj/isql/ISQLSelect.g:419:12: ( LPAREN searchCondition RPAREN )=> LPAREN recCondition= searchCondition RPAREN
                    {
                    LPAREN20=(Token)input.LT(1);
                    match(input,LPAREN,FOLLOW_LPAREN_in_subSearchCondition464); if (failed) return retval;
                    if ( backtracking==0 ) {
                    LPAREN20_tree = (Object)adaptor.create(LPAREN20);
                    adaptor.addChild(root_0, LPAREN20_tree);
                    }
                    pushFollow(FOLLOW_searchCondition_in_subSearchCondition468);
                    recCondition=searchCondition();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, recCondition.getTree());
                    RPAREN21=(Token)input.LT(1);
                    match(input,RPAREN,FOLLOW_RPAREN_in_subSearchCondition470); if (failed) return retval;
                    if ( backtracking==0 ) {
                    RPAREN21_tree = (Object)adaptor.create(RPAREN21);
                    adaptor.addChild(root_0, RPAREN21_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.s = new RecursiveCondition(recCondition.c); 
                    }

                    }


                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:420:11: (predCondition= predicate )
                    {
                    // /home/andrea/prj/isql/ISQLSelect.g:420:11: (predCondition= predicate )
                    // /home/andrea/prj/isql/ISQLSelect.g:420:12: predCondition= predicate
                    {
                    pushFollow(FOLLOW_predicate_in_subSearchCondition488);
                    predCondition=predicate();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, predCondition.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new PredicateCondition(predCondition.p); 
                    }

                    }


                    }
                    break;

            }

            if ( backtracking==0 ) {
               retval.s.setNegated(negated); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end subSearchCondition

    public static class predicate_return extends ParserRuleReturnScope {
        public IPredicate p;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start predicate
    // /home/andrea/prj/isql/ISQLSelect.g:426:1: predicate returns [IPredicate p] : test= whereExpression ( comparisonOperator comparedExp= whereExpression | 'like' comparedText= StringLiteral | 'in' LPAREN ( constantSequence ) RPAREN ) ;
    public final predicate_return predicate() throws RecognitionException {
        predicate_return retval = new predicate_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token comparedText=null;
        Token string_literal23=null;
        Token string_literal24=null;
        Token LPAREN25=null;
        Token RPAREN27=null;
        whereExpression_return test = null;

        whereExpression_return comparedExp = null;

        comparisonOperator_return comparisonOperator22 = null;

        constantSequence_return constantSequence26 = null;


        Object comparedText_tree=null;
        Object string_literal23_tree=null;
        Object string_literal24_tree=null;
        Object LPAREN25_tree=null;
        Object RPAREN27_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:427:5: (test= whereExpression ( comparisonOperator comparedExp= whereExpression | 'like' comparedText= StringLiteral | 'in' LPAREN ( constantSequence ) RPAREN ) )
            // /home/andrea/prj/isql/ISQLSelect.g:428:7: test= whereExpression ( comparisonOperator comparedExp= whereExpression | 'like' comparedText= StringLiteral | 'in' LPAREN ( constantSequence ) RPAREN )
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_whereExpression_in_predicate538);
            test=whereExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, test.getTree());
            // /home/andrea/prj/isql/ISQLSelect.g:428:28: ( comparisonOperator comparedExp= whereExpression | 'like' comparedText= StringLiteral | 'in' LPAREN ( constantSequence ) RPAREN )
            int alt11=3;
            switch ( input.LA(1) ) {
            case EQUAL:
            case NOTEQUAL:
            case LESSTHANOREQUALTO:
            case LESSTHAN:
            case GREATERTHANOREQUALTO:
            case GREATERTHAN:
                {
                alt11=1;
                }
                break;
            case 47:
                {
                alt11=2;
                }
                break;
            case 48:
                {
                alt11=3;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("428:28: ( comparisonOperator comparedExp= whereExpression | 'like' comparedText= StringLiteral | 'in' LPAREN ( constantSequence ) RPAREN )", 11, 0, input);

                throw nvae;
            }

            switch (alt11) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:429:9: comparisonOperator comparedExp= whereExpression
                    {
                    pushFollow(FOLLOW_comparisonOperator_in_predicate550);
                    comparisonOperator22=comparisonOperator();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, comparisonOperator22.getTree());
                    pushFollow(FOLLOW_whereExpression_in_predicate554);
                    comparedExp=whereExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, comparedExp.getTree());
                    if ( backtracking==0 ) {
                       retval.p = new Comparison(test.e, comparedExp.e, input.toString(comparisonOperator22.start,comparisonOperator22.stop)); 
                    }

                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:430:9: 'like' comparedText= StringLiteral
                    {
                    string_literal23=(Token)input.LT(1);
                    match(input,47,FOLLOW_47_in_predicate566); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal23_tree = (Object)adaptor.create(string_literal23);
                    adaptor.addChild(root_0, string_literal23_tree);
                    }
                    comparedText=(Token)input.LT(1);
                    match(input,StringLiteral,FOLLOW_StringLiteral_in_predicate570); if (failed) return retval;
                    if ( backtracking==0 ) {
                    comparedText_tree = (Object)adaptor.create(comparedText);
                    adaptor.addChild(root_0, comparedText_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.p = new Like(test.e, comparedText.getText()); 
                    }

                    }
                    break;
                case 3 :
                    // /home/andrea/prj/isql/ISQLSelect.g:431:13: 'in' LPAREN ( constantSequence ) RPAREN
                    {
                    string_literal24=(Token)input.LT(1);
                    match(input,48,FOLLOW_48_in_predicate586); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal24_tree = (Object)adaptor.create(string_literal24);
                    adaptor.addChild(root_0, string_literal24_tree);
                    }
                    LPAREN25=(Token)input.LT(1);
                    match(input,LPAREN,FOLLOW_LPAREN_in_predicate588); if (failed) return retval;
                    if ( backtracking==0 ) {
                    LPAREN25_tree = (Object)adaptor.create(LPAREN25);
                    adaptor.addChild(root_0, LPAREN25_tree);
                    }
                    // /home/andrea/prj/isql/ISQLSelect.g:431:25: ( constantSequence )
                    // /home/andrea/prj/isql/ISQLSelect.g:431:26: constantSequence
                    {
                    pushFollow(FOLLOW_constantSequence_in_predicate591);
                    constantSequence26=constantSequence();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, constantSequence26.getTree());

                    }

                    RPAREN27=(Token)input.LT(1);
                    match(input,RPAREN,FOLLOW_RPAREN_in_predicate594); if (failed) return retval;
                    if ( backtracking==0 ) {
                    RPAREN27_tree = (Object)adaptor.create(RPAREN27);
                    adaptor.addChild(root_0, RPAREN27_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.p = new In(test.e, constantSequence26.l);  
                    }

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end predicate

    public static class constantSequence_return extends ParserRuleReturnScope {
        public List<IConstant> l = new ArrayList<IConstant>(1);;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start constantSequence
    // /home/andrea/prj/isql/ISQLSelect.g:435:1: constantSequence returns [List<IConstant> l = new ArrayList<IConstant>(1);] : first= constant ( COMMA other= constant )* ;
    public final constantSequence_return constantSequence() throws RecognitionException {
        constantSequence_return retval = new constantSequence_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token COMMA28=null;
        constant_return first = null;

        constant_return other = null;


        Object COMMA28_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:436:5: (first= constant ( COMMA other= constant )* )
            // /home/andrea/prj/isql/ISQLSelect.g:437:5: first= constant ( COMMA other= constant )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_constant_in_constantSequence631);
            first=constant();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, first.getTree());
            if ( backtracking==0 ) {
                retval.l.add(first.c); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:438:5: ( COMMA other= constant )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==COMMA) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:438:6: COMMA other= constant
            	    {
            	    COMMA28=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_constantSequence640); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA28_tree = (Object)adaptor.create(COMMA28);
            	    adaptor.addChild(root_0, COMMA28_tree);
            	    }
            	    pushFollow(FOLLOW_constant_in_constantSequence644);
            	    other=constant();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, other.getTree());
            	    if ( backtracking==0 ) {
            	        retval.l.add(other.c); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end constantSequence

    public static class selectList_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectList
    // /home/andrea/prj/isql/ISQLSelect.g:441:1: selectList options {k=3; } : item= selectItem ( COMMA item= selectItem )* ;
    public final selectList_return selectList() throws RecognitionException {
        selectList_return retval = new selectList_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token COMMA29=null;
        selectItem_return item = null;


        Object COMMA29_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:442:5: (item= selectItem ( COMMA item= selectItem )* )
            // /home/andrea/prj/isql/ISQLSelect.g:443:5: item= selectItem ( COMMA item= selectItem )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_selectItem_in_selectList684);
            item=selectItem();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, item.getTree());
            if ( backtracking==0 ) {
               addSelectItem(item.i); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:444:5: ( COMMA item= selectItem )*
            loop13:
            do {
                int alt13=2;
                int LA13_0 = input.LA(1);

                if ( (LA13_0==COMMA) ) {
                    alt13=1;
                }


                switch (alt13) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:444:7: COMMA item= selectItem
            	    {
            	    COMMA29=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_selectList695); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA29_tree = (Object)adaptor.create(COMMA29);
            	    adaptor.addChild(root_0, COMMA29_tree);
            	    }
            	    pushFollow(FOLLOW_selectItem_in_selectList700);
            	    item=selectItem();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, item.getTree());
            	    if ( backtracking==0 ) {
            	       addSelectItem(item.i); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop13;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectList

    public static class selectItem_return extends ParserRuleReturnScope {
        public SelectItem i;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectItem
    // /home/andrea/prj/isql/ISQLSelect.g:447:1: selectItem returns [SelectItem i] : what= selectExpression 'as' alias= Identifier ;
    public final selectItem_return selectItem() throws RecognitionException {
        selectItem_return retval = new selectItem_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token alias=null;
        Token string_literal30=null;
        selectExpression_return what = null;


        Object alias_tree=null;
        Object string_literal30_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:448:5: (what= selectExpression 'as' alias= Identifier )
            // /home/andrea/prj/isql/ISQLSelect.g:449:5: what= selectExpression 'as' alias= Identifier
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_selectExpression_in_selectItem732);
            what=selectExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, what.getTree());
            string_literal30=(Token)input.LT(1);
            match(input,49,FOLLOW_49_in_selectItem735); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal30_tree = (Object)adaptor.create(string_literal30);
            adaptor.addChild(root_0, string_literal30_tree);
            }
            alias=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_selectItem740); if (failed) return retval;
            if ( backtracking==0 ) {
            alias_tree = (Object)adaptor.create(alias);
            adaptor.addChild(root_0, alias_tree);
            }
            if ( backtracking==0 ) {
               retval.i = new SelectItem(what.e, alias.getText()); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectItem

    public static class fromClause_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start fromClause
    // /home/andrea/prj/isql/ISQLSelect.g:454:1: fromClause : 'from' fromTable= tableSource ( COMMA fromTable= tableSource )* ;
    public final fromClause_return fromClause() throws RecognitionException {
        fromClause_return retval = new fromClause_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal31=null;
        Token COMMA32=null;
        tableSource_return fromTable = null;


        Object string_literal31_tree=null;
        Object COMMA32_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:455:5: ( 'from' fromTable= tableSource ( COMMA fromTable= tableSource )* )
            // /home/andrea/prj/isql/ISQLSelect.g:456:5: 'from' fromTable= tableSource ( COMMA fromTable= tableSource )*
            {
            root_0 = (Object)adaptor.nil();

            string_literal31=(Token)input.LT(1);
            match(input,50,FOLLOW_50_in_fromClause766); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal31_tree = (Object)adaptor.create(string_literal31);
            adaptor.addChild(root_0, string_literal31_tree);
            }
            pushFollow(FOLLOW_tableSource_in_fromClause770);
            fromTable=tableSource();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, fromTable.getTree());
            if ( backtracking==0 ) {
               addTableSource(fromTable.t); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:457:5: ( COMMA fromTable= tableSource )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( (LA14_0==COMMA) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:457:6: COMMA fromTable= tableSource
            	    {
            	    COMMA32=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_fromClause781); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA32_tree = (Object)adaptor.create(COMMA32);
            	    adaptor.addChild(root_0, COMMA32_tree);
            	    }
            	    pushFollow(FOLLOW_tableSource_in_fromClause785);
            	    fromTable=tableSource();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, fromTable.getTree());
            	    if ( backtracking==0 ) {
            	       addTableSource(fromTable.t);  
            	    }

            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end fromClause

    public static class tableSource_return extends ParserRuleReturnScope {
        public TableSource t =  new TableSource();;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start tableSource
    // /home/andrea/prj/isql/ISQLSelect.g:459:1: tableSource returns [ TableSource t = new TableSource(); ] : LSQUARE column= Identifier ( COMMA column= Identifier )* RSQUARE 'as' tableName= Identifier ;
    public final tableSource_return tableSource() throws RecognitionException {
        tableSource_return retval = new tableSource_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token column=null;
        Token tableName=null;
        Token LSQUARE33=null;
        Token COMMA34=null;
        Token RSQUARE35=null;
        Token string_literal36=null;

        Object column_tree=null;
        Object tableName_tree=null;
        Object LSQUARE33_tree=null;
        Object COMMA34_tree=null;
        Object RSQUARE35_tree=null;
        Object string_literal36_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:460:5: ( LSQUARE column= Identifier ( COMMA column= Identifier )* RSQUARE 'as' tableName= Identifier )
            // /home/andrea/prj/isql/ISQLSelect.g:461:5: LSQUARE column= Identifier ( COMMA column= Identifier )* RSQUARE 'as' tableName= Identifier
            {
            root_0 = (Object)adaptor.nil();

            LSQUARE33=(Token)input.LT(1);
            match(input,LSQUARE,FOLLOW_LSQUARE_in_tableSource820); if (failed) return retval;
            if ( backtracking==0 ) {
            LSQUARE33_tree = (Object)adaptor.create(LSQUARE33);
            adaptor.addChild(root_0, LSQUARE33_tree);
            }
            column=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_tableSource824); if (failed) return retval;
            if ( backtracking==0 ) {
            column_tree = (Object)adaptor.create(column);
            adaptor.addChild(root_0, column_tree);
            }
            if ( backtracking==0 ) {
               retval.t.addColumn(column.getText()); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:462:5: ( COMMA column= Identifier )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==COMMA) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:462:6: COMMA column= Identifier
            	    {
            	    COMMA34=(Token)input.LT(1);
            	    match(input,COMMA,FOLLOW_COMMA_in_tableSource835); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    COMMA34_tree = (Object)adaptor.create(COMMA34);
            	    adaptor.addChild(root_0, COMMA34_tree);
            	    }
            	    column=(Token)input.LT(1);
            	    match(input,Identifier,FOLLOW_Identifier_in_tableSource839); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    column_tree = (Object)adaptor.create(column);
            	    adaptor.addChild(root_0, column_tree);
            	    }
            	    if ( backtracking==0 ) {
            	       retval.t.addColumn(column.getText()); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            RSQUARE35=(Token)input.LT(1);
            match(input,RSQUARE,FOLLOW_RSQUARE_in_tableSource851); if (failed) return retval;
            if ( backtracking==0 ) {
            RSQUARE35_tree = (Object)adaptor.create(RSQUARE35);
            adaptor.addChild(root_0, RSQUARE35_tree);
            }
            string_literal36=(Token)input.LT(1);
            match(input,49,FOLLOW_49_in_tableSource853); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal36_tree = (Object)adaptor.create(string_literal36);
            adaptor.addChild(root_0, string_literal36_tree);
            }
            tableName=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_tableSource857); if (failed) return retval;
            if ( backtracking==0 ) {
            tableName_tree = (Object)adaptor.create(tableName);
            adaptor.addChild(root_0, tableName_tree);
            }
            if ( backtracking==0 ) {
               retval.t.setTable(tableName.getText()); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end tableSource

    public static class tableColumn_return extends ParserRuleReturnScope {
        public TableColumn t;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start tableColumn
    // /home/andrea/prj/isql/ISQLSelect.g:469:1: tableColumn returns [ TableColumn t; ] : table= Identifier DOT column= Identifier ;
    public final tableColumn_return tableColumn() throws RecognitionException {
        tableColumn_return retval = new tableColumn_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token table=null;
        Token column=null;
        Token DOT37=null;

        Object table_tree=null;
        Object column_tree=null;
        Object DOT37_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:470:5: (table= Identifier DOT column= Identifier )
            // /home/andrea/prj/isql/ISQLSelect.g:471:5: table= Identifier DOT column= Identifier
            {
            root_0 = (Object)adaptor.nil();

            table=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_tableColumn899); if (failed) return retval;
            if ( backtracking==0 ) {
            table_tree = (Object)adaptor.create(table);
            adaptor.addChild(root_0, table_tree);
            }
            DOT37=(Token)input.LT(1);
            match(input,DOT,FOLLOW_DOT_in_tableColumn901); if (failed) return retval;
            if ( backtracking==0 ) {
            DOT37_tree = (Object)adaptor.create(DOT37);
            adaptor.addChild(root_0, DOT37_tree);
            }
            column=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_tableColumn905); if (failed) return retval;
            if ( backtracking==0 ) {
            column_tree = (Object)adaptor.create(column);
            adaptor.addChild(root_0, column_tree);
            }
            if ( backtracking==0 ) {
               retval.t = new TableColumn(table.getText(), column.getText()); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end tableColumn

    public static class selectExpression_return extends ParserRuleReturnScope {
        public IExpression e;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectExpression
    // /home/andrea/prj/isql/ISQLSelect.g:475:1: selectExpression returns [IExpression e; ] : subA= selectSubExpression (operator= binaryOperator subB= selectSubExpression )* ;
    public final selectExpression_return selectExpression() throws RecognitionException {
        selectExpression_return retval = new selectExpression_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        selectSubExpression_return subA = null;

        binaryOperator_return operator = null;

        selectSubExpression_return subB = null;



        try {
            // /home/andrea/prj/isql/ISQLSelect.g:476:5: (subA= selectSubExpression (operator= binaryOperator subB= selectSubExpression )* )
            // /home/andrea/prj/isql/ISQLSelect.g:477:7: subA= selectSubExpression (operator= binaryOperator subB= selectSubExpression )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_selectSubExpression_in_selectExpression938);
            subA=selectSubExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, subA.getTree());
            if ( backtracking==0 ) {
               retval.e = new SimpleExpression(subA.s); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:478:7: (operator= binaryOperator subB= selectSubExpression )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( ((LA16_0>=MINUS && LA16_0<=BITWISEXOR)) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:478:8: operator= binaryOperator subB= selectSubExpression
            	    {
            	    pushFollow(FOLLOW_binaryOperator_in_selectExpression951);
            	    operator=binaryOperator();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, operator.getTree());
            	    pushFollow(FOLLOW_selectSubExpression_in_selectExpression955);
            	    subB=selectSubExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, subB.getTree());
            	    if ( backtracking==0 ) {
            	       retval.e = new ComplexExpression(retval.e, new SimpleExpression(subB.s), input.toString(operator.start,operator.stop)); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectExpression

    public static class selectSubExpression_return extends ParserRuleReturnScope {
        public SubExpression s;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start selectSubExpression
    // /home/andrea/prj/isql/ISQLSelect.g:481:1: selectSubExpression returns [SubExpression s; ] : ( unaryOperator )? ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction ) ;
    public final selectSubExpression_return selectSubExpression() throws RecognitionException {
        selectSubExpression_return retval = new selectSubExpression_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LPAREN41=null;
        Token RPAREN43=null;
        unaryOperator_return unaryOperator38 = null;

        constant_return constant39 = null;

        function_return function40 = null;

        selectExpression_return selectExpression42 = null;

        tableColumn_return tableColumn44 = null;

        caseFunction_return caseFunction45 = null;


        Object LPAREN41_tree=null;
        Object RPAREN43_tree=null;

         String unop= null; 
        try {
            // /home/andrea/prj/isql/ISQLSelect.g:482:6: ( ( unaryOperator )? ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction ) )
            // /home/andrea/prj/isql/ISQLSelect.g:483:5: ( unaryOperator )? ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction )
            {
            root_0 = (Object)adaptor.nil();

            // /home/andrea/prj/isql/ISQLSelect.g:483:5: ( unaryOperator )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( ((LA17_0>=MINUS && LA17_0<=TILDE)) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:483:6: unaryOperator
                    {
                    pushFollow(FOLLOW_unaryOperator_in_selectSubExpression997);
                    unaryOperator38=unaryOperator();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryOperator38.getTree());
                    if ( backtracking==0 ) {
                       unop=input.toString(unaryOperator38.start,unaryOperator38.stop);  
                    }

                    }
                    break;

            }

            // /home/andrea/prj/isql/ISQLSelect.g:484:5: ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction )
            int alt18=5;
            switch ( input.LA(1) ) {
            case StringLiteral:
            case Number:
            case DateLiteral:
            case 59:
            case 60:
                {
                alt18=1;
                }
                break;
            case Identifier:
                {
                int LA18_2 = input.LA(2);

                if ( (LA18_2==DOT) ) {
                    alt18=4;
                }
                else if ( (LA18_2==LPAREN) ) {
                    alt18=2;
                }
                else {
                    if (backtracking>0) {failed=true; return retval;}
                    NoViableAltException nvae =
                        new NoViableAltException("484:5: ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction )", 18, 2, input);

                    throw nvae;
                }
                }
                break;
            case LPAREN:
                {
                alt18=3;
                }
                break;
            case 51:
                {
                alt18=5;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("484:5: ( constant | function | LPAREN selectExpression RPAREN | tableColumn | caseFunction )", 18, 0, input);

                throw nvae;
            }

            switch (alt18) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:485:7: constant
                    {
                    pushFollow(FOLLOW_constant_in_selectSubExpression1015);
                    constant39=constant();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, constant39.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new ConstantSubExpression(constant39.c); 
                    }

                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:486:7: function
                    {
                    pushFollow(FOLLOW_function_in_selectSubExpression1025);
                    function40=function();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, function40.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new FunctionSubExpression(function40.f); 
                    }

                    }
                    break;
                case 3 :
                    // /home/andrea/prj/isql/ISQLSelect.g:487:7: LPAREN selectExpression RPAREN
                    {
                    LPAREN41=(Token)input.LT(1);
                    match(input,LPAREN,FOLLOW_LPAREN_in_selectSubExpression1035); if (failed) return retval;
                    if ( backtracking==0 ) {
                    LPAREN41_tree = (Object)adaptor.create(LPAREN41);
                    adaptor.addChild(root_0, LPAREN41_tree);
                    }
                    pushFollow(FOLLOW_selectExpression_in_selectSubExpression1037);
                    selectExpression42=selectExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, selectExpression42.getTree());
                    RPAREN43=(Token)input.LT(1);
                    match(input,RPAREN,FOLLOW_RPAREN_in_selectSubExpression1039); if (failed) return retval;
                    if ( backtracking==0 ) {
                    RPAREN43_tree = (Object)adaptor.create(RPAREN43);
                    adaptor.addChild(root_0, RPAREN43_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.s = new ExpressionSubExpression(selectExpression42.e); 
                    }

                    }
                    break;
                case 4 :
                    // /home/andrea/prj/isql/ISQLSelect.g:488:7: tableColumn
                    {
                    pushFollow(FOLLOW_tableColumn_in_selectSubExpression1049);
                    tableColumn44=tableColumn();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, tableColumn44.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new TableColumnSubExpression(tableColumn44.t); 
                    }

                    }
                    break;
                case 5 :
                    // /home/andrea/prj/isql/ISQLSelect.g:489:7: caseFunction
                    {
                    pushFollow(FOLLOW_caseFunction_in_selectSubExpression1060);
                    caseFunction45=caseFunction();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, caseFunction45.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new CaseSubExpression(caseFunction45.c); 
                    }

                    }
                    break;

            }

            if ( backtracking==0 ) {
              retval.s.setUnaryOperator(unop); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end selectSubExpression

    public static class whereExpression_return extends ParserRuleReturnScope {
        public IExpression e;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start whereExpression
    // /home/andrea/prj/isql/ISQLSelect.g:495:1: whereExpression returns [IExpression e; ] : subA= whereSubExpression (operator= binaryOperator subB= whereSubExpression )* ;
    public final whereExpression_return whereExpression() throws RecognitionException {
        whereExpression_return retval = new whereExpression_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        whereSubExpression_return subA = null;

        binaryOperator_return operator = null;

        whereSubExpression_return subB = null;



        try {
            // /home/andrea/prj/isql/ISQLSelect.g:496:5: (subA= whereSubExpression (operator= binaryOperator subB= whereSubExpression )* )
            // /home/andrea/prj/isql/ISQLSelect.g:497:7: subA= whereSubExpression (operator= binaryOperator subB= whereSubExpression )*
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_whereSubExpression_in_whereExpression1113);
            subA=whereSubExpression();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, subA.getTree());
            if ( backtracking==0 ) {
               retval.e = new SimpleExpression(subA.s); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:498:7: (operator= binaryOperator subB= whereSubExpression )*
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( ((LA19_0>=MINUS && LA19_0<=BITWISEXOR)) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:498:8: operator= binaryOperator subB= whereSubExpression
            	    {
            	    pushFollow(FOLLOW_binaryOperator_in_whereExpression1126);
            	    operator=binaryOperator();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, operator.getTree());
            	    pushFollow(FOLLOW_whereSubExpression_in_whereExpression1130);
            	    subB=whereSubExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, subB.getTree());
            	    if ( backtracking==0 ) {
            	       retval.e = new ComplexExpression(retval.e, new SimpleExpression(subB.s), input.toString(operator.start,operator.stop)); 
            	    }

            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end whereExpression

    public static class whereSubExpression_return extends ParserRuleReturnScope {
        public SubExpression s;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start whereSubExpression
    // /home/andrea/prj/isql/ISQLSelect.g:501:1: whereSubExpression returns [SubExpression s; ] : ( unaryOperator )? ( constant | LPAREN whereExpression RPAREN | tableColumn ) ;
    public final whereSubExpression_return whereSubExpression() throws RecognitionException {
        whereSubExpression_return retval = new whereSubExpression_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token LPAREN48=null;
        Token RPAREN50=null;
        unaryOperator_return unaryOperator46 = null;

        constant_return constant47 = null;

        whereExpression_return whereExpression49 = null;

        tableColumn_return tableColumn51 = null;


        Object LPAREN48_tree=null;
        Object RPAREN50_tree=null;

         String unop= null; 
        try {
            // /home/andrea/prj/isql/ISQLSelect.g:502:6: ( ( unaryOperator )? ( constant | LPAREN whereExpression RPAREN | tableColumn ) )
            // /home/andrea/prj/isql/ISQLSelect.g:503:5: ( unaryOperator )? ( constant | LPAREN whereExpression RPAREN | tableColumn )
            {
            root_0 = (Object)adaptor.nil();

            // /home/andrea/prj/isql/ISQLSelect.g:503:5: ( unaryOperator )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( ((LA20_0>=MINUS && LA20_0<=TILDE)) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:503:6: unaryOperator
                    {
                    pushFollow(FOLLOW_unaryOperator_in_whereSubExpression1172);
                    unaryOperator46=unaryOperator();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, unaryOperator46.getTree());
                    if ( backtracking==0 ) {
                       unop=input.toString(unaryOperator46.start,unaryOperator46.stop);  
                    }

                    }
                    break;

            }

            // /home/andrea/prj/isql/ISQLSelect.g:504:5: ( constant | LPAREN whereExpression RPAREN | tableColumn )
            int alt21=3;
            switch ( input.LA(1) ) {
            case StringLiteral:
            case Number:
            case DateLiteral:
            case 59:
            case 60:
                {
                alt21=1;
                }
                break;
            case LPAREN:
                {
                alt21=2;
                }
                break;
            case Identifier:
                {
                alt21=3;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("504:5: ( constant | LPAREN whereExpression RPAREN | tableColumn )", 21, 0, input);

                throw nvae;
            }

            switch (alt21) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:505:7: constant
                    {
                    pushFollow(FOLLOW_constant_in_whereSubExpression1190);
                    constant47=constant();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, constant47.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new ConstantSubExpression(constant47.c); 
                    }

                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:506:7: LPAREN whereExpression RPAREN
                    {
                    LPAREN48=(Token)input.LT(1);
                    match(input,LPAREN,FOLLOW_LPAREN_in_whereSubExpression1200); if (failed) return retval;
                    if ( backtracking==0 ) {
                    LPAREN48_tree = (Object)adaptor.create(LPAREN48);
                    adaptor.addChild(root_0, LPAREN48_tree);
                    }
                    pushFollow(FOLLOW_whereExpression_in_whereSubExpression1202);
                    whereExpression49=whereExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, whereExpression49.getTree());
                    RPAREN50=(Token)input.LT(1);
                    match(input,RPAREN,FOLLOW_RPAREN_in_whereSubExpression1204); if (failed) return retval;
                    if ( backtracking==0 ) {
                    RPAREN50_tree = (Object)adaptor.create(RPAREN50);
                    adaptor.addChild(root_0, RPAREN50_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.s = new ExpressionSubExpression(whereExpression49.e); 
                    }

                    }
                    break;
                case 3 :
                    // /home/andrea/prj/isql/ISQLSelect.g:507:7: tableColumn
                    {
                    pushFollow(FOLLOW_tableColumn_in_whereSubExpression1214);
                    tableColumn51=tableColumn();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, tableColumn51.getTree());
                    if ( backtracking==0 ) {
                       retval.s = new TableColumnSubExpression(tableColumn51.t); 
                    }

                    }
                    break;

            }

            if ( backtracking==0 ) {
              retval.s.setUnaryOperator(unop); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end whereSubExpression

    public static class function_return extends ParserRuleReturnScope {
        public Function f = new Function();;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start function
    // /home/andrea/prj/isql/ISQLSelect.g:514:1: function returns [Function f = new Function(); ] : functionId= Identifier LPAREN (parameter= selectExpression ( COMMA parameter= selectExpression )* )? RPAREN ;
    public final function_return function() throws RecognitionException {
        function_return retval = new function_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token functionId=null;
        Token LPAREN52=null;
        Token COMMA53=null;
        Token RPAREN54=null;
        selectExpression_return parameter = null;


        Object functionId_tree=null;
        Object LPAREN52_tree=null;
        Object COMMA53_tree=null;
        Object RPAREN54_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:515:5: (functionId= Identifier LPAREN (parameter= selectExpression ( COMMA parameter= selectExpression )* )? RPAREN )
            // /home/andrea/prj/isql/ISQLSelect.g:516:5: functionId= Identifier LPAREN (parameter= selectExpression ( COMMA parameter= selectExpression )* )? RPAREN
            {
            root_0 = (Object)adaptor.nil();

            functionId=(Token)input.LT(1);
            match(input,Identifier,FOLLOW_Identifier_in_function1263); if (failed) return retval;
            if ( backtracking==0 ) {
            functionId_tree = (Object)adaptor.create(functionId);
            adaptor.addChild(root_0, functionId_tree);
            }
            if ( backtracking==0 ) {
               retval.f.setFunctionId(functionId.getText()); 
            }
            LPAREN52=(Token)input.LT(1);
            match(input,LPAREN,FOLLOW_LPAREN_in_function1271); if (failed) return retval;
            if ( backtracking==0 ) {
            LPAREN52_tree = (Object)adaptor.create(LPAREN52);
            adaptor.addChild(root_0, LPAREN52_tree);
            }
            // /home/andrea/prj/isql/ISQLSelect.g:517:12: (parameter= selectExpression ( COMMA parameter= selectExpression )* )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==LPAREN||(LA23_0>=StringLiteral && LA23_0<=Identifier)||(LA23_0>=Number && LA23_0<=TILDE)||LA23_0==51||(LA23_0>=59 && LA23_0<=60)) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:518:11: parameter= selectExpression ( COMMA parameter= selectExpression )*
                    {
                    pushFollow(FOLLOW_selectExpression_in_function1287);
                    parameter=selectExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, parameter.getTree());
                    if ( backtracking==0 ) {
                       retval.f.addParameter(parameter.e); 
                    }
                    // /home/andrea/prj/isql/ISQLSelect.g:519:11: ( COMMA parameter= selectExpression )*
                    loop22:
                    do {
                        int alt22=2;
                        int LA22_0 = input.LA(1);

                        if ( (LA22_0==COMMA) ) {
                            alt22=1;
                        }


                        switch (alt22) {
                    	case 1 :
                    	    // /home/andrea/prj/isql/ISQLSelect.g:519:12: COMMA parameter= selectExpression
                    	    {
                    	    COMMA53=(Token)input.LT(1);
                    	    match(input,COMMA,FOLLOW_COMMA_in_function1303); if (failed) return retval;
                    	    if ( backtracking==0 ) {
                    	    COMMA53_tree = (Object)adaptor.create(COMMA53);
                    	    adaptor.addChild(root_0, COMMA53_tree);
                    	    }
                    	    pushFollow(FOLLOW_selectExpression_in_function1307);
                    	    parameter=selectExpression();
                    	    _fsp--;
                    	    if (failed) return retval;
                    	    if ( backtracking==0 ) adaptor.addChild(root_0, parameter.getTree());
                    	    if ( backtracking==0 ) {
                    	       retval.f.addParameter(parameter.e); 
                    	    }

                    	    }
                    	    break;

                    	default :
                    	    break loop22;
                        }
                    } while (true);


                    }
                    break;

            }

            RPAREN54=(Token)input.LT(1);
            match(input,RPAREN,FOLLOW_RPAREN_in_function1328); if (failed) return retval;
            if ( backtracking==0 ) {
            RPAREN54_tree = (Object)adaptor.create(RPAREN54);
            adaptor.addChild(root_0, RPAREN54_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end function

    public static class constant_return extends ParserRuleReturnScope {
        public IConstant c;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start constant
    // /home/andrea/prj/isql/ISQLSelect.g:526:1: constant returns [IConstant c] : ( Number | StringLiteral | DateLiteral | booleanValue );
    public final constant_return constant() throws RecognitionException {
        constant_return retval = new constant_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token Number55=null;
        Token StringLiteral56=null;
        Token DateLiteral57=null;
        booleanValue_return booleanValue58 = null;


        Object Number55_tree=null;
        Object StringLiteral56_tree=null;
        Object DateLiteral57_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:527:5: ( Number | StringLiteral | DateLiteral | booleanValue )
            int alt24=4;
            switch ( input.LA(1) ) {
            case Number:
                {
                alt24=1;
                }
                break;
            case StringLiteral:
                {
                alt24=2;
                }
                break;
            case DateLiteral:
                {
                alt24=3;
                }
                break;
            case 59:
            case 60:
                {
                alt24=4;
                }
                break;
            default:
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("526:1: constant returns [IConstant c] : ( Number | StringLiteral | DateLiteral | booleanValue );", 24, 0, input);

                throw nvae;
            }

            switch (alt24) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:528:5: Number
                    {
                    root_0 = (Object)adaptor.nil();

                    Number55=(Token)input.LT(1);
                    match(input,Number,FOLLOW_Number_in_constant1356); if (failed) return retval;
                    if ( backtracking==0 ) {
                    Number55_tree = (Object)adaptor.create(Number55);
                    adaptor.addChild(root_0, Number55_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.c = new NumberConstant(Number55.getText()); 
                    }

                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:529:7: StringLiteral
                    {
                    root_0 = (Object)adaptor.nil();

                    StringLiteral56=(Token)input.LT(1);
                    match(input,StringLiteral,FOLLOW_StringLiteral_in_constant1366); if (failed) return retval;
                    if ( backtracking==0 ) {
                    StringLiteral56_tree = (Object)adaptor.create(StringLiteral56);
                    adaptor.addChild(root_0, StringLiteral56_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.c = new StringConstant(StringLiteral56.getText()); 
                    }

                    }
                    break;
                case 3 :
                    // /home/andrea/prj/isql/ISQLSelect.g:530:7: DateLiteral
                    {
                    root_0 = (Object)adaptor.nil();

                    DateLiteral57=(Token)input.LT(1);
                    match(input,DateLiteral,FOLLOW_DateLiteral_in_constant1376); if (failed) return retval;
                    if ( backtracking==0 ) {
                    DateLiteral57_tree = (Object)adaptor.create(DateLiteral57);
                    adaptor.addChild(root_0, DateLiteral57_tree);
                    }
                    if ( backtracking==0 ) {
                       retval.c = new DateConstant(DateLiteral57.getText()); 
                    }

                    }
                    break;
                case 4 :
                    // /home/andrea/prj/isql/ISQLSelect.g:531:7: booleanValue
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_booleanValue_in_constant1386);
                    booleanValue58=booleanValue();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, booleanValue58.getTree());
                    if ( backtracking==0 ) {
                       retval.c = new BooleanConstant(input.toString(booleanValue58.start,booleanValue58.stop)); 
                    }

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end constant

    public static class caseWhen_return extends ParserRuleReturnScope {
        public When w;;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start caseWhen
    // /home/andrea/prj/isql/ISQLSelect.g:534:1: caseWhen returns [When w; ] : tableColumn comparisonOperator constant ;
    public final caseWhen_return caseWhen() throws RecognitionException {
        caseWhen_return retval = new caseWhen_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        tableColumn_return tableColumn59 = null;

        comparisonOperator_return comparisonOperator60 = null;

        constant_return constant61 = null;



        try {
            // /home/andrea/prj/isql/ISQLSelect.g:535:5: ( tableColumn comparisonOperator constant )
            // /home/andrea/prj/isql/ISQLSelect.g:536:5: tableColumn comparisonOperator constant
            {
            root_0 = (Object)adaptor.nil();

            pushFollow(FOLLOW_tableColumn_in_caseWhen1414);
            tableColumn59=tableColumn();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, tableColumn59.getTree());
            pushFollow(FOLLOW_comparisonOperator_in_caseWhen1416);
            comparisonOperator60=comparisonOperator();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, comparisonOperator60.getTree());
            pushFollow(FOLLOW_constant_in_caseWhen1418);
            constant61=constant();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, constant61.getTree());
            if ( backtracking==0 ) {
               retval.w = new When(tableColumn59.t, constant61.c, input.toString(comparisonOperator60.start,comparisonOperator60.stop)); 
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end caseWhen

    public static class caseFunction_return extends ParserRuleReturnScope {
        public CaseFunction c = new CaseFunction();;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start caseFunction
    // /home/andrea/prj/isql/ISQLSelect.g:542:1: caseFunction returns [ CaseFunction c = new CaseFunction(); ] : 'case' tableColumn ( 'when' caseWhen 'then' then= selectExpression )+ ( 'else' elseExp= selectExpression )? 'end' ;
    public final caseFunction_return caseFunction() throws RecognitionException {
        caseFunction_return retval = new caseFunction_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal62=null;
        Token string_literal64=null;
        Token string_literal66=null;
        Token string_literal67=null;
        Token string_literal68=null;
        selectExpression_return then = null;

        selectExpression_return elseExp = null;

        tableColumn_return tableColumn63 = null;

        caseWhen_return caseWhen65 = null;


        Object string_literal62_tree=null;
        Object string_literal64_tree=null;
        Object string_literal66_tree=null;
        Object string_literal67_tree=null;
        Object string_literal68_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:543:5: ( 'case' tableColumn ( 'when' caseWhen 'then' then= selectExpression )+ ( 'else' elseExp= selectExpression )? 'end' )
            // /home/andrea/prj/isql/ISQLSelect.g:543:7: 'case' tableColumn ( 'when' caseWhen 'then' then= selectExpression )+ ( 'else' elseExp= selectExpression )? 'end'
            {
            root_0 = (Object)adaptor.nil();

            string_literal62=(Token)input.LT(1);
            match(input,51,FOLLOW_51_in_caseFunction1440); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal62_tree = (Object)adaptor.create(string_literal62);
            adaptor.addChild(root_0, string_literal62_tree);
            }
            pushFollow(FOLLOW_tableColumn_in_caseFunction1442);
            tableColumn63=tableColumn();
            _fsp--;
            if (failed) return retval;
            if ( backtracking==0 ) adaptor.addChild(root_0, tableColumn63.getTree());
            if ( backtracking==0 ) {
               retval.c.setTest(tableColumn63.t); 
            }
            // /home/andrea/prj/isql/ISQLSelect.g:544:11: ( 'when' caseWhen 'then' then= selectExpression )+
            int cnt25=0;
            loop25:
            do {
                int alt25=2;
                int LA25_0 = input.LA(1);

                if ( (LA25_0==52) ) {
                    alt25=1;
                }


                switch (alt25) {
            	case 1 :
            	    // /home/andrea/prj/isql/ISQLSelect.g:544:12: 'when' caseWhen 'then' then= selectExpression
            	    {
            	    string_literal64=(Token)input.LT(1);
            	    match(input,52,FOLLOW_52_in_caseFunction1457); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    string_literal64_tree = (Object)adaptor.create(string_literal64);
            	    adaptor.addChild(root_0, string_literal64_tree);
            	    }
            	    pushFollow(FOLLOW_caseWhen_in_caseFunction1459);
            	    caseWhen65=caseWhen();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, caseWhen65.getTree());
            	    string_literal66=(Token)input.LT(1);
            	    match(input,53,FOLLOW_53_in_caseFunction1461); if (failed) return retval;
            	    if ( backtracking==0 ) {
            	    string_literal66_tree = (Object)adaptor.create(string_literal66);
            	    adaptor.addChild(root_0, string_literal66_tree);
            	    }
            	    pushFollow(FOLLOW_selectExpression_in_caseFunction1465);
            	    then=selectExpression();
            	    _fsp--;
            	    if (failed) return retval;
            	    if ( backtracking==0 ) adaptor.addChild(root_0, then.getTree());
            	    if ( backtracking==0 ) {
            	       retval.c.addWhenThen(new WhenThen(caseWhen65.w, then.e)); 
            	    }

            	    }
            	    break;

            	default :
            	    if ( cnt25 >= 1 ) break loop25;
            	    if (backtracking>0) {failed=true; return retval;}
                        EarlyExitException eee =
                            new EarlyExitException(25, input);
                        throw eee;
                }
                cnt25++;
            } while (true);

            // /home/andrea/prj/isql/ISQLSelect.g:546:5: ( 'else' elseExp= selectExpression )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==54) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:546:6: 'else' elseExp= selectExpression
                    {
                    string_literal67=(Token)input.LT(1);
                    match(input,54,FOLLOW_54_in_caseFunction1497); if (failed) return retval;
                    if ( backtracking==0 ) {
                    string_literal67_tree = (Object)adaptor.create(string_literal67);
                    adaptor.addChild(root_0, string_literal67_tree);
                    }
                    pushFollow(FOLLOW_selectExpression_in_caseFunction1501);
                    elseExp=selectExpression();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, elseExp.getTree());
                    if ( backtracking==0 ) {
                      retval.c.setElse(elseExp.e); 
                    }

                    }
                    break;

            }

            string_literal68=(Token)input.LT(1);
            match(input,55,FOLLOW_55_in_caseFunction1512); if (failed) return retval;
            if ( backtracking==0 ) {
            string_literal68_tree = (Object)adaptor.create(string_literal68);
            adaptor.addChild(root_0, string_literal68_tree);
            }

            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end caseFunction

    public static class unaryOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start unaryOperator
    // /home/andrea/prj/isql/ISQLSelect.g:551:1: unaryOperator : ( MINUS | TILDE );
    public final unaryOperator_return unaryOperator() throws RecognitionException {
        unaryOperator_return retval = new unaryOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set69=null;

        Object set69_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:552:5: ( MINUS | TILDE )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set69=(Token)input.LT(1);
            if ( (input.LA(1)>=MINUS && input.LA(1)<=TILDE) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set69));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_unaryOperator0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end unaryOperator

    public static class binaryOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start binaryOperator
    // /home/andrea/prj/isql/ISQLSelect.g:556:1: binaryOperator : ( arithmeticOperator | bitwiseOperator );
    public final binaryOperator_return binaryOperator() throws RecognitionException {
        binaryOperator_return retval = new binaryOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        arithmeticOperator_return arithmeticOperator70 = null;

        bitwiseOperator_return bitwiseOperator71 = null;



        try {
            // /home/andrea/prj/isql/ISQLSelect.g:557:5: ( arithmeticOperator | bitwiseOperator )
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==MINUS||(LA27_0>=PLUS && LA27_0<=MOD)) ) {
                alt27=1;
            }
            else if ( (LA27_0==TILDE||(LA27_0>=AMPERSAND && LA27_0<=BITWISEXOR)) ) {
                alt27=2;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                NoViableAltException nvae =
                    new NoViableAltException("556:1: binaryOperator : ( arithmeticOperator | bitwiseOperator );", 27, 0, input);

                throw nvae;
            }
            switch (alt27) {
                case 1 :
                    // /home/andrea/prj/isql/ISQLSelect.g:558:5: arithmeticOperator
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_arithmeticOperator_in_binaryOperator1565);
                    arithmeticOperator70=arithmeticOperator();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, arithmeticOperator70.getTree());

                    }
                    break;
                case 2 :
                    // /home/andrea/prj/isql/ISQLSelect.g:558:26: bitwiseOperator
                    {
                    root_0 = (Object)adaptor.nil();

                    pushFollow(FOLLOW_bitwiseOperator_in_binaryOperator1569);
                    bitwiseOperator71=bitwiseOperator();
                    _fsp--;
                    if (failed) return retval;
                    if ( backtracking==0 ) adaptor.addChild(root_0, bitwiseOperator71.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end binaryOperator

    public static class arithmeticOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start arithmeticOperator
    // /home/andrea/prj/isql/ISQLSelect.g:561:1: arithmeticOperator : ( PLUS | MINUS | STAR | DIVIDE | MOD );
    public final arithmeticOperator_return arithmeticOperator() throws RecognitionException {
        arithmeticOperator_return retval = new arithmeticOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set72=null;

        Object set72_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:562:5: ( PLUS | MINUS | STAR | DIVIDE | MOD )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set72=(Token)input.LT(1);
            if ( input.LA(1)==MINUS||(input.LA(1)>=PLUS && input.LA(1)<=MOD) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set72));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_arithmeticOperator0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end arithmeticOperator

    public static class bitwiseOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start bitwiseOperator
    // /home/andrea/prj/isql/ISQLSelect.g:566:1: bitwiseOperator : ( AMPERSAND | TILDE | BITWISEOR | BITWISEXOR );
    public final bitwiseOperator_return bitwiseOperator() throws RecognitionException {
        bitwiseOperator_return retval = new bitwiseOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set73=null;

        Object set73_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:567:5: ( AMPERSAND | TILDE | BITWISEOR | BITWISEXOR )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set73=(Token)input.LT(1);
            if ( input.LA(1)==TILDE||(input.LA(1)>=AMPERSAND && input.LA(1)<=BITWISEXOR) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set73));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_bitwiseOperator0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end bitwiseOperator

    public static class comparisonOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start comparisonOperator
    // /home/andrea/prj/isql/ISQLSelect.g:571:1: comparisonOperator : ( EQUAL | NOTEQUAL | LESSTHANOREQUALTO | LESSTHAN | GREATERTHANOREQUALTO | GREATERTHAN );
    public final comparisonOperator_return comparisonOperator() throws RecognitionException {
        comparisonOperator_return retval = new comparisonOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set74=null;

        Object set74_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:572:5: ( EQUAL | NOTEQUAL | LESSTHANOREQUALTO | LESSTHAN | GREATERTHANOREQUALTO | GREATERTHAN )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set74=(Token)input.LT(1);
            if ( (input.LA(1)>=EQUAL && input.LA(1)<=GREATERTHAN) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set74));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_comparisonOperator0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end comparisonOperator

    public static class logicalOperator_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start logicalOperator
    // /home/andrea/prj/isql/ISQLSelect.g:577:1: logicalOperator : ( 'all' | 'and' | 'any' | 'exists' | 'in' | 'like' | 'not' | 'or' | 'some' );
    public final logicalOperator_return logicalOperator() throws RecognitionException {
        logicalOperator_return retval = new logicalOperator_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set75=null;

        Object set75_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:578:5: ( 'all' | 'and' | 'any' | 'exists' | 'in' | 'like' | 'not' | 'or' | 'some' )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set75=(Token)input.LT(1);
            if ( input.LA(1)==36||(input.LA(1)>=43 && input.LA(1)<=44)||(input.LA(1)>=46 && input.LA(1)<=48)||(input.LA(1)>=56 && input.LA(1)<=58) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set75));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_logicalOperator0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end logicalOperator

    public static class booleanValue_return extends ParserRuleReturnScope {
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start booleanValue
    // /home/andrea/prj/isql/ISQLSelect.g:582:1: booleanValue : ( 'true' | 'false' );
    public final booleanValue_return booleanValue() throws RecognitionException {
        booleanValue_return retval = new booleanValue_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token set76=null;

        Object set76_tree=null;

        try {
            // /home/andrea/prj/isql/ISQLSelect.g:583:5: ( 'true' | 'false' )
            // /home/andrea/prj/isql/ISQLSelect.g:
            {
            root_0 = (Object)adaptor.nil();

            set76=(Token)input.LT(1);
            if ( (input.LA(1)>=59 && input.LA(1)<=60) ) {
                input.consume();
                if ( backtracking==0 ) adaptor.addChild(root_0, adaptor.create(set76));
                errorRecovery=false;failed=false;
            }
            else {
                if (backtracking>0) {failed=true; return retval;}
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_booleanValue0);    throw mse;
            }


            }

            retval.stop = input.LT(-1);

            if ( backtracking==0 ) {
                retval.tree = (Object)adaptor.rulePostProcessing(root_0);
                adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);
            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return retval;
    }
    // $ANTLR end booleanValue

    // $ANTLR start synpred14
    public final void synpred14_fragment() throws RecognitionException {   
        // /home/andrea/prj/isql/ISQLSelect.g:419:11: ( ( ( LPAREN searchCondition RPAREN )=> LPAREN searchCondition RPAREN ) )
        // /home/andrea/prj/isql/ISQLSelect.g:419:11: ( ( LPAREN searchCondition RPAREN )=> LPAREN searchCondition RPAREN )
        {
        // /home/andrea/prj/isql/ISQLSelect.g:419:11: ( ( LPAREN searchCondition RPAREN )=> LPAREN searchCondition RPAREN )
        // /home/andrea/prj/isql/ISQLSelect.g:419:12: ( LPAREN searchCondition RPAREN )=> LPAREN searchCondition RPAREN
        {
        match(input,LPAREN,FOLLOW_LPAREN_in_synpred14464); if (failed) return ;
        pushFollow(FOLLOW_searchCondition_in_synpred14468);
        searchCondition();
        _fsp--;
        if (failed) return ;
        match(input,RPAREN,FOLLOW_RPAREN_in_synpred14470); if (failed) return ;

        }


        }
    }
    // $ANTLR end synpred14

    public final boolean synpred14() {
        backtracking++;
        int start = input.mark();
        try {
            synpred14_fragment(); // can never throw exception
        } catch (RecognitionException re) {
            System.err.println("impossible: "+re);
        }
        boolean success = !failed;
        input.rewind(start);
        backtracking--;
        failed=false;
        return success;
    }


 

    public static final BitSet FOLLOW_selectStatement_in_statement65 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_statement67 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_selectClause_in_selectStatement85 = new BitSet(new long[]{0x0004000000000000L});
    public static final BitSet FOLLOW_fromClause_in_selectStatement91 = new BitSet(new long[]{0x000020C000000002L});
    public static final BitSet FOLLOW_whereClause_in_selectStatement98 = new BitSet(new long[]{0x0000208000000002L});
    public static final BitSet FOLLOW_groupByClause_in_selectStatement107 = new BitSet(new long[]{0x0000008000000002L});
    public static final BitSet FOLLOW_orderByClause_in_selectStatement116 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_35_in_selectClause145 = new BitSet(new long[]{0x180800300000F1A0L});
    public static final BitSet FOLLOW_set_in_selectClause150 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectList_in_selectClause169 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_38_in_whereClause192 = new BitSet(new long[]{0x180040000000F1A0L});
    public static final BitSet FOLLOW_searchCondition_in_whereClause194 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_39_in_orderByClause219 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_40_in_orderByClause221 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_orderByExpression_in_orderByClause225 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_COMMA_in_orderByClause234 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_orderByExpression_in_orderByClause238 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_tableColumn_in_orderByExpression275 = new BitSet(new long[]{0x0000060000000002L});
    public static final BitSet FOLLOW_set_in_orderByExpression286 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_subSearchCondition_in_searchCondition325 = new BitSet(new long[]{0x0000180000000002L});
    public static final BitSet FOLLOW_set_in_searchCondition337 = new BitSet(new long[]{0x180040000000F1A0L});
    public static final BitSet FOLLOW_subSearchCondition_in_searchCondition347 = new BitSet(new long[]{0x0000180000000002L});
    public static final BitSet FOLLOW_45_in_groupByClause379 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_40_in_groupByClause381 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_tableColumn_in_groupByClause385 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_COMMA_in_groupByClause394 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_tableColumn_in_groupByClause396 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_46_in_subSearchCondition434 = new BitSet(new long[]{0x180000000000F1A0L});
    public static final BitSet FOLLOW_LPAREN_in_subSearchCondition464 = new BitSet(new long[]{0x180040000000F1A0L});
    public static final BitSet FOLLOW_searchCondition_in_subSearchCondition468 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RPAREN_in_subSearchCondition470 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_predicate_in_subSearchCondition488 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_whereExpression_in_predicate538 = new BitSet(new long[]{0x000180001F800000L});
    public static final BitSet FOLLOW_comparisonOperator_in_predicate550 = new BitSet(new long[]{0x180000000000F1A0L});
    public static final BitSet FOLLOW_whereExpression_in_predicate554 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_47_in_predicate566 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_StringLiteral_in_predicate570 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_48_in_predicate586 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_LPAREN_in_predicate588 = new BitSet(new long[]{0x1800000000003080L});
    public static final BitSet FOLLOW_constantSequence_in_predicate591 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RPAREN_in_predicate594 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_constant_in_constantSequence631 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_COMMA_in_constantSequence640 = new BitSet(new long[]{0x1800000000003080L});
    public static final BitSet FOLLOW_constant_in_constantSequence644 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_selectItem_in_selectList684 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_COMMA_in_selectList695 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectItem_in_selectList700 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_selectExpression_in_selectItem732 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_49_in_selectItem735 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_selectItem740 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_50_in_fromClause766 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_tableSource_in_fromClause770 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_COMMA_in_fromClause781 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_tableSource_in_fromClause785 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_LSQUARE_in_tableSource820 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_tableSource824 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_COMMA_in_tableSource835 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_tableSource839 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_RSQUARE_in_tableSource851 = new BitSet(new long[]{0x0002000000000000L});
    public static final BitSet FOLLOW_49_in_tableSource853 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_tableSource857 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_tableColumn899 = new BitSet(new long[]{0x0000000000000800L});
    public static final BitSet FOLLOW_DOT_in_tableColumn901 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_Identifier_in_tableColumn905 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_selectSubExpression_in_selectExpression938 = new BitSet(new long[]{0x00000000007FC002L});
    public static final BitSet FOLLOW_binaryOperator_in_selectExpression951 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectSubExpression_in_selectExpression955 = new BitSet(new long[]{0x00000000007FC002L});
    public static final BitSet FOLLOW_unaryOperator_in_selectSubExpression997 = new BitSet(new long[]{0x18080000000031A0L});
    public static final BitSet FOLLOW_constant_in_selectSubExpression1015 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_function_in_selectSubExpression1025 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_selectSubExpression1035 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectExpression_in_selectSubExpression1037 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RPAREN_in_selectSubExpression1039 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tableColumn_in_selectSubExpression1049 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_caseFunction_in_selectSubExpression1060 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_whereSubExpression_in_whereExpression1113 = new BitSet(new long[]{0x00000000007FC002L});
    public static final BitSet FOLLOW_binaryOperator_in_whereExpression1126 = new BitSet(new long[]{0x180000000000F1A0L});
    public static final BitSet FOLLOW_whereSubExpression_in_whereExpression1130 = new BitSet(new long[]{0x00000000007FC002L});
    public static final BitSet FOLLOW_unaryOperator_in_whereSubExpression1172 = new BitSet(new long[]{0x18000000000031A0L});
    public static final BitSet FOLLOW_constant_in_whereSubExpression1190 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_whereSubExpression1200 = new BitSet(new long[]{0x180000000000F1A0L});
    public static final BitSet FOLLOW_whereExpression_in_whereSubExpression1202 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RPAREN_in_whereSubExpression1204 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tableColumn_in_whereSubExpression1214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Identifier_in_function1263 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_LPAREN_in_function1271 = new BitSet(new long[]{0x180800000000F1E0L});
    public static final BitSet FOLLOW_selectExpression_in_function1287 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_COMMA_in_function1303 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectExpression_in_function1307 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_RPAREN_in_function1328 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_Number_in_constant1356 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_StringLiteral_in_constant1366 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DateLiteral_in_constant1376 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_booleanValue_in_constant1386 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_tableColumn_in_caseWhen1414 = new BitSet(new long[]{0x000000001F800000L});
    public static final BitSet FOLLOW_comparisonOperator_in_caseWhen1416 = new BitSet(new long[]{0x1800000000003080L});
    public static final BitSet FOLLOW_constant_in_caseWhen1418 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_51_in_caseFunction1440 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_tableColumn_in_caseFunction1442 = new BitSet(new long[]{0x0010000000000000L});
    public static final BitSet FOLLOW_52_in_caseFunction1457 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_caseWhen_in_caseFunction1459 = new BitSet(new long[]{0x0020000000000000L});
    public static final BitSet FOLLOW_53_in_caseFunction1461 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectExpression_in_caseFunction1465 = new BitSet(new long[]{0x00D0000000000000L});
    public static final BitSet FOLLOW_54_in_caseFunction1497 = new BitSet(new long[]{0x180800000000F1A0L});
    public static final BitSet FOLLOW_selectExpression_in_caseFunction1501 = new BitSet(new long[]{0x0080000000000000L});
    public static final BitSet FOLLOW_55_in_caseFunction1512 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_unaryOperator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arithmeticOperator_in_binaryOperator1565 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_bitwiseOperator_in_binaryOperator1569 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_arithmeticOperator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_bitwiseOperator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_comparisonOperator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_logicalOperator0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_booleanValue0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAREN_in_synpred14464 = new BitSet(new long[]{0x180040000000F1A0L});
    public static final BitSet FOLLOW_searchCondition_in_synpred14468 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RPAREN_in_synpred14470 = new BitSet(new long[]{0x0000000000000002L});

}