/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql;

import org.antlr.runtime.ANTLRStringStream;
import org.antlr.runtime.CommonTokenStream;
import org.antlr.runtime.RecognitionException;
import org.junit.Test;

/**
 * 
 * @author SHZ Sep 25, 2007
 */
public class ISQLSelectParserTest
{

	/**
	 * Test method for {@link isql.ISQLSelectParser#statement()}.
	 * @throws RecognitionException 
	 */
	@Test
	public void testStatement() throws RecognitionException
	{
		String sql = "select distinct "
			+"case price.ticker when price.ticker = '' then 'zozzo' else price.ticker end as ticker"
			+", sum(price.fix) as sumfix, sum(price.ask) as sumask"
			+" from [ticker, fix, ask] as price"
			+" where price.fix > price.ask"
			+" and not price.fix > 39"
			+" group by price.ticker"
			+" order by price.ticker desc"
			;
		applyQuery(sql);
	}
	
	public static ISQLSelectParser applyQuery(String sql) throws RecognitionException
	{
        ISQLSelectLexer lex = new ISQLSelectLexer(new ANTLRStringStream(sql));
        CommonTokenStream tokens = new CommonTokenStream(lex);
        ISQLSelectParser g = new ISQLSelectParser(tokens);  
        g.statement();
        return g;
	}		

	@Test
	public void testStatement2() throws RecognitionException
	{
		String sql = "select price.ticker as ticker, sum(price.fix) as sumfix, sum(price.ask) as sumask"
			+" from [ticker, fix, ask] as price"
			+" group by price.ticker"
			+" order by price.ticker"
			;
		applyQuery(sql);
	}

}
