/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql;

import isql.util.SystemLogger;

import org.junit.Test;

/**
 * @author SHZ Dec 7, 2007
 *
 */
public class SQLParserTest
{

	/**
	 * Test method for {@link isql.SQLParser#buildParser(java.lang.String)}.
	 * @throws ISQLException 
	 */
	@Test
	public void testBuildParser() throws ISQLException
	{
		SQLParser parser = new SQLParser(new SystemLogger());
		parser.buildParser("select a.a1 as aa1, b.b1 as bb1, c.c1 as cc1" +
				"\nfrom [a1] as a, [b1] as b, [c1] as c" +
				"\nwhere (a.a1 = b.b1 or c.c1 = a.a1)" +
				"\nand c.c1 = b.b1");
		
		parser.buildParser("select a.a1 as aa1, b.b1 as bb1, c.c1 as cc1" +
				"\nfrom [a1] as a, [b1] as b, [c1] as c" +
				"\nwhere (a.a1 = b.b1 or c.c1 = a.a1)" +
				"\nand c.c1 = b.b1");
		
	}

}
