/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.array;

import java.util.Arrays;

import isql.ColumnType;
import isql.ITypedValue;

/**
 * An array with its type
 * @author SHZ Sep 27, 2007
 */
public class Array implements ITypedValue
{
	/**
	 * The array expressed as an object so that
	 * we can handle it independently by its content
	 */
	private Object[] array;
	/**
	 * The array's type
	 */
	private ColumnType type;
	public Array(Object[] array, ColumnType type)
	{
		this.array = array;
		this.type = type;
	}
	/**
	 * the array
	 * @return the array
	 */
	public Object[] getArray()
	{
		return array;
	}
	/**
	 * The type of the array
	 * @return the type
	 */
	public ColumnType getType()
	{
		return type;
	}
	
	/**
	 * The size of the array
	 * @return the array size
	 */
	public int getSize()
	{
		return array.length;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return Arrays.toString(array);
	}
	
}
