/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.builder;

import java.util.HashMap;
import java.util.Map;

import isql.help.scalar.IBinaryScalar;
import isql.help.scalar.numeric.DivideScalar;
import isql.help.scalar.numeric.MinusScalar;
import isql.help.scalar.numeric.ModScalar;
import isql.help.scalar.numeric.PlusScalar;
import isql.help.scalar.numeric.TimesScalar;

/**
 * @author SHZ Oct 16, 2007
 *
 */
public class BinaryOperatorBuilder
{
	private Map<String, IBinaryScalar> mapOperator = new HashMap<String, IBinaryScalar>(); 
	
	public BinaryOperatorBuilder()
	{
		mapOperator.put("+", new PlusScalar());
		mapOperator.put("-", new MinusScalar());
		mapOperator.put("*", new TimesScalar());
		mapOperator.put("/", new DivideScalar());
		mapOperator.put("%", new ModScalar());
	}
	
	public IBinaryScalar buildBinaryOperator(String operator)
	{
		return mapOperator.get(operator);
	}

}
