/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.comparison;

import isql.IComparison;
import isql.ISQLException;

/**
 * Used as predicate to check if element a is smaller than element b
 * @author SHZ Sep 28, 2007
 */
public class Less implements IComparison
{

	/* (non-Javadoc)
	 * @see isql.comparison.IComparison#compareBoolean(boolean, boolean)
	 */
	@SuppressWarnings("unchecked")
	public boolean compare(Object a, Object b)
			throws ISQLException
	{
		return ((Comparable)a).compareTo(b) < 0;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "<";
	}
}
