/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.constant;

import isql.IConstant;

import java.sql.Timestamp;

import isql.ColumnType;

/**
 * A date constant (e.g. #2007-10-28#
 * @author SHZ Sep 28, 2007
 */
public class DateConstant implements IConstant
{
	/**
	 * The constant value
	 */
	private Timestamp value;
	
	
	public DateConstant(Timestamp value)
	{
		this.value = value;
	}


	/* (non-Javadoc)
	 * @see isql.ITypedValue#getType()
	 */
	public ColumnType getType()
	{
		return ColumnType.DATE;
	}


	/**
	 * @return the value
	 */
	public Timestamp getValue()
	{
		return value;
	}
	/* (non-Javadoc)
	 * @see isql.IConstant#getValueAsObject()
	 */
	public Object getValueAsObject()
	{
		return getValue();
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return value.toString();
	}
}
