/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.constant;

import isql.IConstant;
import isql.ColumnType;

/**
 * A numeric constant
 * @author SHZ Sep 28, 2007
 */
public class NumericConstant implements IConstant
{
	/**
	 * The constant value
	 */
	private Double value;
	
	
	public NumericConstant(Double value)
	{
		this.value = value;
	}


	/* (non-Javadoc)
	 * @see isql.ITypedValue#getType()
	 */
	public ColumnType getType()
	{
		return ColumnType.NUMERIC;
	}


	/**
	 * @return the value
	 */
	public Double getValue()
	{
		return value;
	}
	/* (non-Javadoc)
	 * @see isql.IConstant#getValueAsObject()
	 */
	public Object getValueAsObject()
	{
		return getValue();
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return String.valueOf(value);
	}

}
