/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.constant;

import isql.IConstant;
import isql.ColumnType;

/**
 * A text constant
 * @author SHZ Sep 28, 2007
 */
public class TextConstant implements IConstant
{
	/**
	 * The constant value
	 */
	private String value;
	
	public TextConstant(String value)
	{
		this.value = value;
	}

	/* (non-Javadoc)
	 * @see isql.ITypedValue#getType()
	 */
	public ColumnType getType()
	{
		return ColumnType.TEXT;
	}

	/**
	 * @return the value
	 */
	public String getValue()
	{
		return value;
	}
	/* (non-Javadoc)
	 * @see isql.IConstant#getValueAsObject()
	 */
	public Object getValueAsObject()
	{
		return getValue();
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return value;
	}
}
