/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.expression;

import isql.Column;
import isql.ColumnKey;
import isql.ISQLException;
import isql.ITypedValue;

import java.util.Set;
import java.util.TreeSet;


/**
 * An expression composed by a single column
 * @author SHZ Oct 1, 2007
 */
public class ColumnExpressionSimple implements ISimpleExpression, IWhereExpression
{
	/**
	 * The column that composes the expression
	 */
	private Column column;
	
	public ColumnExpressionSimple(Column column)
	{
		this.column = column;
	}
	/* (non-Javadoc)
	 * @see isql.IExpression#getResult()
	 */
	public ITypedValue getResult() throws ISQLException
	{
		return column.getArray();
	}
	/* (non-Javadoc)
	 * @see isql.IExpression#getInvolvedColumns()
	 */
	public Set<ColumnKey> getInvolvedColumns()
	{
		Set<ColumnKey> setColumnKey = new TreeSet<ColumnKey>();
		setColumnKey.add(column.getKey());
		return setColumnKey;
	}
	/*
	 * NOT USED
	public boolean[] applyView(WhereView view)
	{
		String tableName = column.getKey().getTableName();
		boolean[] arrMatchingView = new boolean[column.getArray().getSize()];
		if(view.hasTable(tableName))
		{			
			List<Integer> lstIndex = view.getIndicesInTable(tableName);
			for(Integer index : lstIndex)
				arrMatchingView[index.intValue()] = true;
			return arrMatchingView;
		}
		else
		{
			// if the column does not have anything to do with the case constraint, 
			// all records are 
			Arrays.fill(arrMatchingView, true);
		}
		return arrMatchingView;
	}
	*/
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "[COLUMNEXPRESSION "+column+"]";
	}
}
