/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.expression;

import isql.ColumnKey;
import isql.IConstant;
import isql.ISQLException;
import isql.ITypedValue;

import java.util.Set;
import java.util.TreeSet;


/**
 * Expression consiting of just a constant, like a number or a string
 * @author SHZ Oct 1, 2007
 */
public class ConstantExpression implements ISimpleExpression, IWhereExpression
{
	private IConstant constant;
	
	
	public ConstantExpression(IConstant constant)
	{
		this.constant = constant;
	}


	/* (non-Javadoc)
	 * @see isql.IExpression#getResult()
	 */
	public ITypedValue getResult() throws ISQLException
	{
		return constant;
	}


	/* (non-Javadoc)
	 * @see isql.IExpression#getInvolvedColumns()
	 */
	public Set<ColumnKey> getInvolvedColumns()
	{
		return new TreeSet<ColumnKey>();
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		return "[CONSTANTEXPRESSION "+constant+"]";
	}

}
