/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.expression;

import isql.ColumnType;
import isql.ISQLException;
import isql.array.Array;
import isql.help.scalar.numeric.DivideScalar;
import isql.test.JUnitMatrices;
import isql.util.ArrayBuilder;
import isql.util.JUnitISQL;

import org.junit.Test;

/**
 * @author SHZ Nov 8, 2007
 *
 */
public class DoubleExpressionTest
{

	/**
	 * Test method for {@link isql.expression.DoubleExpression#getResult()}.
	 * @throws ISQLException 
	 */
	@Test
	public void testGetResult() throws ISQLException
	{
		ColumnExpressionSimple a = new ColumnExpressionSimple(JUnitISQL.buildNumericalColumn("test.a", new double[] { 2, 4, 6, 8, 10}));
		ColumnExpressionSimple b = new ColumnExpressionSimple(JUnitISQL.buildNumericalColumn("test.b", new double[] { 1, 2, 3, 4, 5 }));
		DoubleExpression dbl = new DoubleExpression(a, b, new DivideScalar());
		Array res = (Array) dbl.getResult();
		JUnitMatrices.assertEquals(res.getArray(), ArrayBuilder.convertToBig(ColumnType.NUMERIC, new double[] { 2,2,2,2,2} ));
		
	}

}
