/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */

package isql.expression;

import isql.IExpression;

/**
 * A WHEN-THEN substatement of a CASE statement
 * @see CaseExpression
 * @author SHZ Oct 1, 2007
 */
public class WhenThen
{
	/**
	 * The when part of the statement
	 */
	private When when;
	/**
	 * The then part of the statement
	 */
	private IExpression then;
	public WhenThen(When when, IExpression then)
	{
		this.when = when;
		this.then = then;
	}
	/**
	 * @return the when
	 */
	public When getWhen()
	{
		return when;
	}
	/**
	 * @return the then
	 */
	public IExpression getThen()
	{
		return then;
	}

}
