/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.expression.aggregate;

/**
 * Returns the minimum value among them added using the add method
 * @author SHZ Oct 31, 2007
 */
public class Min implements IAggregate
{

	Object min = null;
	/* (non-Javadoc)
	 * @see isql.expression.aggregate.IAggregate#add(java.lang.Object)
	 */
	@SuppressWarnings("unchecked")
	public void add(Object value)
	{
		if(min == null || ((Comparable)value).compareTo(min) < 0)
			min = value;
	}

	/* (non-Javadoc)
	 * @see isql.expression.aggregate.IAggregate#getSum()
	 */
	public Object getSum()
	{
		return min;
	}
}
