/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.predicate;

import isql.ISQLException;
import isql.comparison.Equal;
import isql.expression.ColumnExpressionSimple;
import isql.test.JUnitMatrices;
import isql.util.ArrayBuilder;
import isql.util.JUnitISQL;

import org.junit.Test;

/**
 * @author SHZ Nov 8, 2007
 *
 */
public class ComparisonPredicateTest
{

	/**
	 * Test method for {@link isql.predicate.ComparisonPredicate#apply()}.
	 * @throws ISQLException 
	 */
	@Test
	public void testApply() throws ISQLException
	{
		ColumnExpressionSimple a = new ColumnExpressionSimple(JUnitISQL.buildNumericalColumn("test.a", new double[] { 1, 2, 3, 4, 5}));
		ColumnExpressionSimple b = new ColumnExpressionSimple(JUnitISQL.buildNumericalColumn("test.b", new double[] { 1, 2, 3, 4, 5 }));
		ComparisonPredicate predicateAB = new ComparisonPredicate(a, b, new Equal());
		WhereView view = predicateAB.apply();
		JUnitMatrices.assertEquals(view.getTableNames(), new String[] { "test" });
		JUnitMatrices.assertEquals(view.getIndicesInTable("test").toArray(new Integer[5]), ArrayBuilder.convertToBigInteger(new int[] { 0,1,2,3,4 }));
		
		
	}

}
