/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.predicate;

/**
 * To merge two views using a table as pivot (the so-called merge table, the table to
 * which the views have both relations in terms of rows indices)
 * @author SHZ Oct 18, 2007
 */
interface IMergeRows
{
	/**
	 * merges the two tables
	 * @param toFind the view the row indices of which are searched in the "in" view
	 * @param in the view that is searched in
	 * @param tableName the merge table
	 * @param viewRes the view resulting from the merge operation
	 */
	public abstract void mergeRows(WhereView toFind, WhereView in,
			String tableName, WhereView viewRes);

}