/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.predicate;

import static org.junit.Assert.assertEquals;
import isql.IConstant;
import isql.ISQLException;
import isql.constant.TextConstant;
import isql.expression.ColumnExpressionSimple;
import isql.util.JUnitISQL;

import java.util.List;

import org.junit.Test;

/**
 * @author SHZ Nov 7, 2007
 *
 */
public class InPredicateTest
{

	/**
	 * Test method for {@link isql.predicate.InPredicate#apply()}.
	 * @throws ISQLException 
	 */
	@Test
	public void testApply() throws ISQLException
	{
		ColumnExpressionSimple test = new ColumnExpressionSimple(JUnitISQL.buildTextColumn("test.like", new String[] { "giovanni", "armando", "giacomo" }));
		IConstant[] inClause = new IConstant[] { new TextConstant("giovanni"), new TextConstant("giacomo") };
		InPredicate predicate = new InPredicate(test, inClause, null, false);
		WhereView view = predicate.apply();
		List<Integer> lstRes = view.getIndicesInTable("test");
		assertEquals(lstRes.size(), 2);
		assertEquals(lstRes.get(0).intValue(), 0);
		assertEquals(lstRes.get(1).intValue(), 2);

		predicate = new InPredicate(test, inClause, null, true);
		view = predicate.apply();
		lstRes = view.getIndicesInTable("test");
		assertEquals(lstRes.size(), 1);
		assertEquals(lstRes.get(0).intValue(), 1);

	}

}
