package isql.predicate;

import isql.ColumnValues;
import isql.IPredicate;
import isql.ISQLException;

import java.util.List;


/**
 * It is builds a view resulting from the "OR" of two predicates in the WHERE clause
 * @author SHZ Oct 18, 2007
 */
public class OrPredicate implements IPredicate
{
	/**
	 * The OR predicate is a double predicate (connects two predicates with an AND) 
	 */	
	private DoublePredicate doublePredicate;
	
	public OrPredicate(List<IPredicate> lstPredicate, ColumnValues values)
	{
		doublePredicate = new DoublePredicate(lstPredicate, new DoublePredicate.MergeRowsOr(), values);
	}
	
	/* (non-Javadoc)
	 * @see isql.IPredicate#apply()
	 */
	public WhereView apply() throws ISQLException
	{
		return doublePredicate.apply();
	}

	@Override
	public String toString()
	{
		return "OR("+doublePredicate+")";
	}
	
}
