/*
 * Copyright (C) 2008 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.util;


/**
 * A wrapper to the logging library (log4j or java.util.logging?)
 * to log inside in this library
 * @author SHZ Apr 7, 2008
 */
public interface ILogger
{
	/**
	 * Logs an error with an exception
	 * @param msg the error text
	 * @param thrown the exception 
	 */
	public void error(String msg, Throwable thrown);
		
	/**
	 * Logs an error
	 * @param msg the error text
	 */
	public void error(String msg);		
		
	/**
	 * Logs a debug message
	 * @param msg the debug messsage
	 */
	public void debug(String msg);
		
	/**
	 * Logs an information message
	 * @param msg the info message
	 */
	public void info(String msg);		
}
