/*
 * Copyright (C) 2008 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.util;

import isql.Column;
import isql.ColumnKey;
import isql.ColumnType;
import isql.array.Array;

/**
 * Utility functions to test the system using JUnit
 * @author SHZ Feb 1, 2008
 */
public class JUnitISQL
{
	/**
	 * Converts an array of numbers (double[]) to a table column
	 * @param columnName the column identifier in form of <table name>.<column name>
	 * @param arrValues the array
	 * @return the built Column object
	 */
	public static Column buildNumericalColumn(String columnName, double[] arrValues)
	{
		Column column = new Column(ColumnKey.fromString(columnName), 
				new Array(ArrayBuilder.convertToBig(ColumnType.NUMERIC, arrValues), ColumnType.NUMERIC));
		return column;
	}

	/**
	 * Converts an array of texts (String[]) to a table column
	 * @param columnName the column identifier in form of <table name>.<column name>
	 * @param arrValues the array
	 * @return the built Column object
	 */	
	public static Column buildTextColumn(String columnName, String[] arrValues)
	{
		Column column = new Column(ColumnKey.fromString(columnName), 
				new Array(arrValues, ColumnType.TEXT));
		return column;
	}

}
