/*
 * Copyright (C) 2007 Andrea Ferrandi <aferrandi@users.sourceforge.net>. 
 * Released under the terms of the GNU LGPL v3.0.
 */
package isql.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Helper for maps of lists
 * A map of list is a map of type:
 * 		map<K, List<V>>
 * which means a map that can have 0+ values for each key
 * @author SHZ Oct 17, 2007
 */
public class MapOfListHelp
{
	/**
	 * Adds a value to the map of lists
	 * @param <K> the key type  
	 * @param <V> the value type
	 * @param mapOfLists the map of lists
	 * @param key the key to add the value for 
	 * @param value the value to add
	 */
	public static <K,V> void put(Map<K, List<V>> mapOfLists, K key, V value)
	{
		List<V> lstValueForKey = mapOfLists.get(key);
		if(lstValueForKey == null)
		{
			lstValueForKey = new ArrayList<V>();
			mapOfLists.put(key, lstValueForKey);
		}
		lstValueForKey.add(value);
	}
	
}
