package isql.util;


/**
 * Default implementation of the ILogger wrapper that uses the System streams (System.out, System.err).
 * Used in the tests
 * @author SHZ Apr 7, 2008
 */
public class SystemLogger implements ILogger
{
	public void debug(String msg)
	{
		System.out.println("DEBUG: "+msg);
	}

	public void error(String msg, Throwable thrown)
	{
		System.err.print("ERROR: "+msg+" "+thrown.getMessage());
		thrown.printStackTrace(System.err);
		System.err.println();
	}

	public void error(String msg)
	{
		System.out.println("ERROR: "+msg);
	}

	public void info(String msg)
	{
		System.out.println("INFO: "+msg);
	}
}
